Package: R4RNA
Type: Package
Title: An R package for RNA visualization and analysis
Version: 1.38.0
Date: 2015-11-02
Author: Daniel Lai, Irmtraud Meyer <irmtraud.meyer@cantab.net>
Maintainer: Daniel Lai <jujubix@cs.ubc.ca>
Depends: R (>= 3.2.0), Biostrings (>= 2.38.0)
Description: A package for RNA basepair analysis, including the visualization of basepairs as arc diagrams for easy comparison and annotation of sequence
                 and structure.  Arc diagrams can additionally be projected onto multiple sequence alignments to assess basepair conservation and
                 covariation, with numerical methods for computing statistics for each.
License: GPL-3
biocViews: Alignment, MultipleSequenceAlignment, Preprocessing,
        Visualization, DataImport, DataRepresentation,
        MultipleComparison
URL: http://www.e-rna.org/r-chie/
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/R4RNA
git_branch: RELEASE_3_22
git_last_commit: 90fdbbd
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 05:54:16 UTC; biocbuild

## Copyright (C) 2011 Daniel Lai and Irmtraud M. Meyer (www.e-rna.org)
## Contact information: irmtraud.meyer@cantab.net

## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

as.helix <- function(x, length = NULL) {
    x <- as.data.frame(x)
    if (nrow(x) == 0) {
        x <- data.frame(i = vector(), j = vector(), length = vector(),
            value = vector())
    }

    if(ncol(x) < 4) {
        stop("Expecting data.frame-like structure with at least 4 columns")
    }
    names <- colnames(x)
    names[1:4] <- c("i", "j", "length", "value")
    colnames(x) <- names
    rownames(x) <- NULL
    x$i <- as.integer(x$i)
    x$j <- as.integer(x$j)
    x$length <- as.integer(x$length)
    x$value <- as.numeric(x$value)

    if (is.null(length)) {
        length <- max(x$i, x$j)
    }

    attr(x, "length") <- length
    return(x)
}

is.helix <- function(x) {
    valid <- TRUE
    if (!is.data.frame(x)) {
        warning("Not a valid data frame")
        valid <- FALSE
    }
    if (ncol(x) < 4) {
        warning("Should have at least 4 columns")
        valid <- FALSE
    }
    if (is.null(attr(x, "length"))) {
        warning("No length attribute")
        valid <- FALSE
    }
    if (!all(lapply(x, class)[1:4] == c("integer", "integer", "integer",
            "numeric"))) {
        warning("Columns of invalid class")
        valid <- FALSE
    }
    if(!all(colnames(x)[1:4] == c("i", "j", "length", "value"))) {
        warning("Invalid column names")
        valid <- FALSE
    }
    return(valid)
}

collapseHelix <- function(helix, number = FALSE) {
    if(!is.helix(helix)) {
        stop("Input is not a valid helix, aborting")
    } else {
        if (nrow(helix) == 0) {
            return(helix)
        }
        helix <- expandHelix(helix)
        helix <- helix[!duplicated(helix), ]
    }
    length <- attr(helix, "length")

    tmp <- NA
    if (any(is.na(helix$value))) {
        tmp <- max(helix$value, na.rm = TRUE) + 1
        helix$value[is.na(helix$value)] <- tmp
    }

    sums <- rowSums(helix[, 1:2])
    if (number) {
        order <- order(helix$number, sums, helix$i)
    } else {
        order <- order(helix$value, sums, helix$i)
    }
    helix <- helix[order, ]
    sums <- sums[order]

    vend <- rep(FALSE, nrow(helix))
    vsta <- rep(FALSE, nrow(helix))

    # Change in number/value indicates helix end
    if (number) {
        ends <- findInterval(unique(helix$number), helix$number)
        vend[ends] <- TRUE
        vsta[c(0, ends[-length(ends)]) + 1] <- TRUE
    } else {
        ends <- findInterval(unique(helix$value), helix$value)
        vend[ends] <- TRUE
        vsta[c(0, ends[-length(ends)]) + 1] <- TRUE
    }

    # Change in basepair sum indicates helix end
    ends <- cumsum(rle(sums)$lengths)
    vend[ends] <- TRUE
    vsta[c(0, ends[-length(ends)]) + 1] <- TRUE

    # Basepair position difference != 1 indicates helix end
    ends <- which(c(diff(helix$i), 0) != 1)
    vend[ends] <- TRUE
    vsta[c(0, ends[-length(ends)]) + 1] <- TRUE

    starts <- which(vsta)
    ends <- which(vend)
    counts <- which(vend) - which(vsta) + 1
    ungap <- (helix$i[vsta] == helix$i[vend] - counts + 1) &
        (helix$j[vsta] == helix$j[vend] + counts - 1)

    if (length(which(ungap == FALSE)) > 0) {
        stop("This error should never occur... inform developer if it does")
    }

    output <- helix[vsta, ]
    output$length <- counts
    
    if (!is.na(tmp)) {
        output$value[which(output$value == tmp)] <- NA
    }
    
    return(as.helix(output, length))
}

expandHelix <- function(helix) {
    if(!is.helix(helix)) {
        stop("Input is not a valid helix, aborting")
    } else {
        if (nrow(helix) == 0 || all(helix$length == 1)) {
            return(helix)
        }
    }
    length <- attr(helix, "length")
    
    output <- as.data.frame(matrix(NA, sum(helix$length), ncol(helix)))

    # Compute i
    diff <- rep(1, sum(helix$length))
    end_index <- cumsum(helix$length)
    start_index <- c(0, end_index[-length(end_index)]) + 1

    # Compute j
    end_pos <- helix$i + helix$length - 1
    diff[start_index] <- helix$i - c(0, end_pos[-length(end_pos)])
    output[, 1] <- cumsum(diff)
    

    diff <- rep(-1, sum(helix$length))
    end_pos <- helix$j - helix$length + 1
    diff[start_index] <- helix$j - c(0, end_pos[-length(end_pos)])
    output[, 2] <- cumsum(diff)

    output[, 3] <- 1
    
    for (i in 4:ncol(helix)) {
        output[, i] <- rep(helix[, i], helix$length)
    }

    colnames(output) <- colnames(helix)
    return(as.helix(output, length))
}

expandNumberedHelix <- function(helix) {
    number <- rep(1:nrow(helix), helix$length)
    helix <- expandHelix(helix)
    helix$number <- number
    return(helix)    
}

isConflictingHelix <- function(helix) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting...")
    }
    if (nrow(helix) == 0) {
        return (vector())
    }
    if (nrow(helix) == 1) {
        return(c(FALSE))
    }
    
    helix <- expandNumberedHelix(helix)
    end <- nrow(helix)
    helix$bad <- 1
    for (i in 1:(end - 1)) {
        if (helix$bad[i] == 1) {
            kill <- which(helix$i[(i + 1):end] == helix$i[i] |
                helix$j[(i + 1):end] == helix$j[i] |
                helix$j[(i + 1):end] == helix$i[i] |
                helix$i[(i + 1):end] == helix$j[i])
            helix$bad[kill + i] <- 0
        }
    }
    return(aggregate(1 - helix$bad, by = list(helix$number), mean)$x)
}

isDuplicatingHelix <- function(helix) {
    if (!is.helix(helix)) {
        stop("Invalid helix data frame, aborting")
    }

    if(nrow(helix) == 0) {
        return (vector())
    }

    expand <- expandNumberedHelix(helix)
    flip <- which(expand$i > expand$j)
    tmp <- expand$i[flip]
    expand$i[flip] <- expand$j[flip]
    expand$j[flip] <- tmp
    expand$duplicate <- duplicated(expand[, c("i", "j")])
    return(aggregate(expand$duplicate, by = list(expand$number), mean)$x)
}

isOverlappingHelix <- function(helix, query) {
    if(!is.helix(helix) | !is.helix(query)) {
        stop("One of the inputs was not a valid helix data frame, aborting")
    }

    if (nrow(helix) == 0) {
        return (vector());
    }
    if (nrow(query) == 0) {
        return (rep(0, helix))
    }

    helix <- expandNumberedHelix(as.helix(helix[, 1:4]))
    y <- expandHelix(query)[, 1:4]
    y$length <- NULL
    y$value <- NULL
    y$hit <- 1
    helix <- merge(helix, y, all.x = TRUE)
    helix$hit[is.na(helix$hit)] <- 0
    return(aggregate(helix$hit, by = list(helix$number), mean)$x)
}

logseq <- function(from, to, length.out) {
    if (missing(length.out)) {
        length.out <- log10(max(from, to) / min(from, to)) + 1
    }
    return(exp(seq(log(from), log(to), length.out = length.out)))
}

logfloor <- function(x) {
    return(10 ** floor(log10(x)))
}

logceiling <- function(x) {
    return(10 ** ceiling(log10(x)))
}

basepairFrequency <- function(helix) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting")
    }
    if (nrow(helix) == 0) {
        return(helix)
    } else {
        basepairs <- expandHelix(helix)[, c("i", "j")]
    }
    counts <- table(paste(basepairs$i, basepairs$j))
    pos <- as.integer(unlist(strsplit(names(counts), " ")))
    odds <- seq(1, length(pos), by = 2)
    output <- data.frame(i = pos[odds], j = pos[odds + 1], length = 1,
        value = as.integer(counts))
    output <- output[order(-output$value, output$i, output$j), ]
    return(as.helix(output, attr(helix, "length")))
}

# Returns a logical row each row of the matrix, TRUE of pseudoknotted, else
# false. Assumes these are  helices of LENGTH 1
is_pseudoknotted <- function(row, matrix) {
    return((row$i <= matrix$i & matrix$i <= row$j & row$j <= matrix$j) |
    (matrix$i <= row$i & row$i <= matrix$j & matrix$j <= row$j))
}

# Adds a group column, in which helices of each numbered group are
# non-pseudoknotted
unknottedGroups <- function(helix) {
    if (!is.helix(helix)) {
        stop("Invalid input")
    }
    if (any(helix$length > 1)) {
        warning("Expanding helix to basepairs")
        helix <- expandHelix(helix)
    }
    if (nrow(helix) == 0) {
        stop("No basepairs in helix")
    }
    group <- rep(0, nrow(helix));
     group[1] <- 1
    if (nrow(helix) == 1) {
        return(group)
    }
    for (i in 2:nrow(helix)) {
        test <- 1
        while (any(is_pseudoknotted(helix[i, ], helix[which(group == test), ]))) {
            test <- test + 1
        }
        group[i] <- test
    }
    return(group)
}

## Copyright (C) 2011 Daniel Lai and Irmtraud M. Meyer (www.e-rna.org)
## Contact information: irmtraud.meyer@cantab.net

## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

blankPlot <- function(width, top, bottom, pad = c(0, 0, 0, 0),
        scale = TRUE, scale.lwd = 1, scale.col = "#DDDDDD", scale.cex = 1,
        debug = FALSE, png = NA, pdf = NA, factor = ifelse(!is.na(png), 8, 1/9),
        no.par = FALSE, asp = 1, ...) {
    x <- width + pad[2] + pad[4]
    # x <- max(x, 115) # width of longest legend
    y <- top - bottom + pad[1] + pad[3]
    if (!is.na(png)) {
        png(png, x * factor, y * factor)
    } else {
        if (!is.na(pdf)) {
            pdf(pdf, x * factor, y * factor)
        }
    }
    if (!no.par) { par(oma = c(0, 0, 0, 0), mar = c(0, 0, 0, 0), ...) }
    plot(c(0 - pad[2], width + pad[4]), c(bottom - pad[1], top + pad[3]),
        type = "n", axes = FALSE, xlab = "", ylab = "", asp = asp)
    if (scale) {
        plotScale(width, top, bottom, col = scale.col, lwd = scale.lwd,
            cex = scale.cex, xpd = TRUE)
    }
    if (debug) {
        print(paste("width", width, sep = ": "))
        print(paste("top", top, sep = ": "))
        print(paste("bottom", bottom, sep = ": "))
        print(paste("left", -pad[2], sep = ": "))
        print(paste("right", pad[4], sep = ": "))
        abline(h = c(top, bottom), col = "red", lty = 2)
        abline(v = c(-pad[2], width + pad[4]), col = "red")
        abline(h = 0, col = "green")
        abline(v = width, col = "green")
    }
}

plotScale <- function(width, top, bottom, ...) {
    pt <- strheight("0")
    bars <- pretty(c(1, width), n = 10)
    bars <- bars[which(bars <= width)]
    segments(bars, bottom - 1, y1 = top + 1.5 * pt, ...)
    text(bars, top + 1.5 * pt, bars, adj = c(-0.25, 1), ...)
}

maxHeight <- function(helix) {
    if(nrow(helix) == 0) {
        return(0)
    } else {
        return(max(abs(helix$i - helix$j)) / 2)
    }
}

arc <- function (c, r, v, theta, ...) {
    angles <- anglesArc(v, theta)
    seqang <- seq(angles[1], angles[2], length = 100)
    x <- c[1] + r * cos(seqang)
    y <- c[2] + r * sin(seqang)
    lines(x, y, ...)
}

anglesArc <- function (v, theta) {
    theta.OX <- ifelse(v[2] >= 0, acos(v[1]), 2 * pi - acos(v[1]))
    angs <- c(theta.OX - theta, theta.OX + theta)
    return(angs)
}

plotArrow <- function(start, y = 0, length = start * 0.03) {
    # NOTE: R has an automatic 4% margin for pretty axes, length is 3% default
    h <- (length / 4)
    polygon(c(start, start + length, start), c(h, 0, -h) + y, col = 1)
}

priority <- c("GC" = 1, "CG" = 2, "UA" = 3, "AU" = 4, "GU" = 5, "UG" = 6)

getCovarianceColours <- function(msa, helix) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    cols <- matrix(5, nrow = (length(msa)), ncol = nchar(msa[1]))
    bases <- strsplit(msa, "")
    chars <- matrix(nrow = length(bases), ncol = length(bases[[1]]))
    if (nrow(helix) > 0 & is.helix(helix)) {
        for (i in 1:length(msa)) {
            bases[[i]] <- toupper(bases[[i]])
            bases[[i]] <- sub("T", "U", bases[[i]])
            chars[i, ] <- bases[[i]]
            col <- getSequenceColour(msa[i], helix)
            cols[i, ] <- col
        }
        if (length(msa) == 1) {
            cols[1, which(cols[1, ] == 2)] <- 1
        } else {
            for (i in 1:nrow(helix)) {
                # Colours conservation relative to the most common valid basepair
                pos <- as.integer(helix[i, c("i", "j")])
                bases <- chars[, pos]
                pairs <- apply(bases, 1, paste, collapse = "")
                counts <- table(pairs[which(cols[, pos[1]] == 2)])
                if(length(counts) > 0) {
                    max <- names(priority)[min(priority[names(which(counts ==
                        max(counts)))])]
                    cols[which(pairs == max), pos] <- 1

                    # One-sided conservation colouring
                    maxchar <- unlist(strsplit(max, ""))
                    blues <- which(cols[, pos[1]] == 2)
                    hits <- blues[which(bases[blues, 1] == maxchar[1])]
                    cols[hits, pos[1]] <- 1
                    cols[hits, pos[2]] <- 3
                    hits <- blues[which(bases[blues, 2] == maxchar[2])]
                    cols[hits, pos[2]] <- 1
                    cols[hits, pos[1]] <- 3
                }
            }
        }
    }
    return(cols)
}

getBaseColours <- function(msa) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    msa <- toupper(msa)
    msa <- gsub("[.]", "-", msa)
    msa <- gsub("T", "U", msa)
    msa <- gsub("[^ACGU-]", "N", msa)
    cols <- matrix(7, nrow = length(msa), ncol = nchar(msa[1]))
    map <- c("A" = 1, "U" = 2, "G" = 3, "C" = 4, "-" = 5, "N" = 6)
    for(i in 1:length(msa)) {
        s <- msa[i]
        for(j in 1:nchar(s)) {
            col <- map[as.character(toupper(substr(s, j, j)))]
            if(!is.na(col)) { cols[i, j] <- col }
        }
    }
    return(cols)
}

getSequenceColour <- function(msa, helix) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    msa <- toupper(msa)
    msa <- gsub("[.]", "-", msa)
    msa <- gsub("T", "U", msa)
    msa <- gsub("[^ACGU-]", "N", msa)
    cols <- rep(5, nchar(msa))
    chars <- unlist(strsplit(msa, ""))
    cols[which(chars == '-')] <- 6
    cols[which(chars == 'N')] <- 7
    for(i in 1:nrow(helix)) {
        pos <- as.integer(helix[i, c("i", "j")])
        col <- bpCols[chars[pos[1]], chars[pos[2]]]
        cols[pos[1]] <- col[[1]][1]
        cols[pos[2]] <- col[[1]][2]
    }
    return(cols)
}

bpCols <- matrix(list(c(4, 4)), ncol = 6, nrow = 6)
rownames(bpCols) <- c("G", "C", "A", "U", "-", "N")
colnames(bpCols) <- c("G", "C", "A", "U", "-", "N")
bpCols["A", "U"] <- list(c(2, 2))
bpCols["U", "A"] <- list(c(2, 2))
bpCols["G", "C"] <- list(c(2, 2))
bpCols["C", "G"] <- list(c(2, 2))
bpCols["G", "U"] <- list(c(2, 2))
bpCols["U", "G"] <- list(c(2, 2))
bpCols["-", "G"] <- list(c(6, 4))
bpCols["-", "C"] <- list(c(6, 4))
bpCols["-", "A"] <- list(c(6, 4))
bpCols["-", "U"] <- list(c(6, 4))
bpCols["G", "-"] <- list(c(4, 6))
bpCols["C", "-"] <- list(c(4, 6))
bpCols["A", "-"] <- list(c(4, 6))
bpCols["U", "-"] <- list(c(4, 6))
bpCols["-", "-"] <- list(c(6, 6))
bpCols["N",    ] <- list(c(7, 7))
bpCols[   , "N"] <- list(c(7, 7))
bpCols["N", "-"] <- list(c(7, 6))
bpCols["-", "N"] <- list(c(6, 7))

plotArc <- function(i, j, x = 0, y = 0, flip = FALSE, shape = "circle", ...) {
    i <- as.numeric(i) + x
    j <- as.numeric(j) + x
    if (shape == "circle") {
        center <- c(mean(c(i, j)), y)
        radius <- abs(diff(c(i, j))) / 2
        vector <- c(0, ifelse(flip, -1, 1))
        theta <- pi/2
        arc(center, radius, vector, theta, ...)
    } else {
        width <- abs(i - j)
        height <- (width / 2) + y
        height <- ifelse(flip, -height, height)
        if (shape == "triangle") {
            center <- (i + j)/ 2
            lines(c(i, center, j), c(y, height, y), ...)
        } else {
            if (shape == "square") {
                lines(c(i, i, j, j), c(y, height, height, y), ...)
            }
        }
    }
}

plotArcs <- function(i, j, length, x = 0, y = 0, flip = FALSE,
    shape = "circle", ...) {
    i <- as.numeric(i)
    j <- as.numeric(j)
    for (n in 0:(length - 1)) {
        plotArc(i + n, j - n, x, y, flip, shape = shape, ...)
    }
}

plotHelix <- function(helix, x = 0, y = 0, flip = FALSE, line = FALSE,
        arrow = FALSE, add = FALSE, shape = "circle", ...) {
    if (!is.helix(helix)) {
        stop("Input not a valid helix data frame, aborting")
    }
    if (nrow(helix) > 0) {
        if (is.null(helix$flip)) {
            helix$flip <- flip
        }
        if (is.null(helix$y)) {
            helix$y <- y
        }
        if (is.null(helix$shape)) {
            helix$shape <- shape
        }
        style <- NULL
        width <- attr(helix, "length")
        if(ncol(helix) > 4) {
            types <- lapply(helix, typeof)
            names <- names(helix)
            for (i in 5:ncol(helix)) {
                helix[names[i]] <- paste(names[i], " = ", "as.", types[i], "('",
                    unlist(helix[i]), "')", sep = "")
            }
            helix$cmd <- apply(data.frame(helix[, 5:ncol(helix)]), 1, paste,
                collapse = ", ")
            helix <- helix[, c("i", "j", "length", "value", "cmd")]
        }
        if (!add) {
            blankPlot(width, maxHeight(helix), 0, ...)
        }

        # Reversed so top helices appear on top of lower helices
        for (n in nrow(helix):1) {
            if (!is.null(helix$cmd)) {
                cmd <- paste("plotArcs(helix$i[n], helix$j[n], helix$length[n], x,", helix$cmd[n], ")")
                eval(parse(text = cmd))
            } else {
                plotArcs(helix$i[n], helix$j[n], helix$length[n], x, y,
                    flip = flip, shape = shape)
            }

        }
        if (line) {
            lines(c(0.5, width + 0.5), c(y, y), col = 1)
        }
    
        if (arrow) {
            plotArrow(width + 0.5, y)
        }
    } else {
        warning("Input structure is empty, no helices plotted")
    }

}

plotDoubleHelix <- function(top, bot, line = TRUE, arrow = FALSE, add = FALSE,
        ...) {
    if (!is.helix(top) || !is.helix(bot)) {
        stop("Input not a valid helix data frame, aborting")
    }
    width <- max(attr(top, "length"), attr(bot, "length"))
    if (!add) {
        blankPlot(width, maxHeight(top), -maxHeight(bot), ...)
    }
    plotHelix(top, add = TRUE, ...)
    plotHelix(bot, flip = TRUE, add = TRUE, ...)

    if (line) {
        lines(c(0.5, width + 0.5), c(0, 0), col = 1)
    }
    
    if (arrow) {
        plotArrow(width + 0.5)
    }
}

plotOverlapHelix <- function(predict, known, miss = "black", line = TRUE,
    arrow = FALSE, add = FALSE, overlap.cutoff = 1, ...) {
    if (!is.helix(predict) || !is.helix(known)) {
        stop("Input not a valid helix data frame, aborting")
    }
    width <- max(attr(predict, "length"), attr(known, "length"))

    predict$flip <- FALSE
    overlap <- isOverlappingHelix(predict, known) >= overlap.cutoff
    predict$flip[which(!overlap)] <- TRUE

    misses <-
        known[which(isOverlappingHelix(known, predict) < overlap.cutoff), ]

    if (!add) {
        top <- max(maxHeight(predict[which(predict$flip == FALSE), ]),
            maxHeight(misses))
        bot <- maxHeight(predict[which(predict$flip == TRUE), ])
        blankPlot(width, top, -bot, ...)
    }

    if (nrow(misses) > 0) {
        plotHelix(misses, col = miss, add = TRUE, ...)
    }
    plotHelix(predict, add = TRUE, ...)

    if (line) {
        lines(c(0.5, width + 0.5), c(0, 0), col = 1)
    }    
    if (arrow) {
        plotArrow(width + 0.5)
    }
}

plotCovarianceLine <- function(x, y, cols, ...) {
    x <- x - 0.5
    start <- x:(x + length(cols) - 1)
    end <- start + 1
    segments(start, y, end, col = cols, lend = 1, ...)
}

plotCovarianceGrid <- function(x, y, cols, height = 1.25, ...) {
    x <- x - 0.5
    start <- x:(x + length(cols) - 1)
    end <- start + 1
    top <- y
    bot <- y + height
    rect(start, bot, end, top, col = cols, ...)
}

plotCovarianceText <- function(x, y, text, height = 1.25, ...) {
    # font = 2, family = "sans"
    chars <- unlist(strsplit(text, ""))
    start <- 1:length(chars) + x - 1
    # 'font': c(san-serif, bold, italics, bold italics, serif)
    # 'family': "mono", "serif", "sans"
    text(start, y + height / 2, chars, ...)
}

plotCovarianceSpecies <- function(x, y, text, height = 1.25, ...) {
     # font = 3, family = "mono", adj = 0
    text(-x, y + height / 2, text, adj = 0, ...)
}

plotOverlapCovariance <- function(predict.helix, known.helix, msa,
        bot.msa = TRUE, overlap.cutoff = 1, miss = "black", add = FALSE,
        grid = FALSE, species = 0, legend = TRUE, pad = c(0, 0, 0, 0), ...) {
    if (!is.helix(predict.helix) || !is.helix(known.helix)) {
        stop("One of input not a valid helix data frame, aborting")
    }
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    width <- max(nchar(msa))
    height <- ifelse(grid, 1.25, 1)

    overlap <- isOverlappingHelix(predict.helix, known.helix) >= overlap.cutoff
    tp <- predict.helix[overlap, ]
    fp <- predict.helix[!overlap, ]
    fn <- known.helix[isOverlappingHelix(known.helix, predict.helix) < overlap.cutoff, ]
    if (nrow(fn) > 0) {
        fn$col <- miss
    }

    offset <- (length(msa) + 0.5) * height
    up <- max(maxHeight(tp), maxHeight(fn)) + offset
    down <- maxHeight(fp) + ifelse(bot.msa, offset, 0)

    if (!add) {
        if (species > 0) {
            pad[2] <- pad[2] + species
        }
        suppressWarnings(blankPlot(width, up, -down, pad, ...))
    }

    if (bot.msa) {
        plotCovariance(msa, fp, add = TRUE, flip = TRUE, grid = grid,
            species = species, legend = FALSE, y = -height/2, ...)        
    } else {
        plotHelix(fp, add = TRUE, flip = TRUE, y = height/2, ...)
    }
    if (nrow(fn) > 0) {
        plotHelix(fn, add = TRUE, y = offset - ifelse(grid, 0, 1), ...)
    }
    plotHelix(tp, add = TRUE, y = offset - ifelse(grid, 0, 1), ...)
    plotCovariance(msa, known.helix, add = TRUE, arcs = FALSE, grid = grid,
        species = species, legend = legend, y = height/2, ...)
}

plotDoubleCovariance <- function(top.helix, bot.helix, top.msa, bot.msa =
        top.msa, add = FALSE, grid = FALSE, species = 0, legend = TRUE,
        pad = c(0, 0, 0, 0), ...) {
    if (!is.helix(top.helix) || !is.helix(bot.helix)) {
        stop("One of input not a valid helix data frame, aborting")
    }
    if (is(top.msa, "XStringSet")) {
        top.msa <- as.character(top.msa)
    }
    if (is(bot.msa, "XStringSet")) {
        bot.msa <- as.character(bot.msa)
    }
    width <- max(nchar(c(top.msa, bot.msa)), na.rm = TRUE)
    height <- ifelse(grid, 1.25, 1)

    up <- maxHeight(top.helix) + (length(top.msa) + 0.5) * height
    down <- maxHeight(bot.helix) + (length(bot.msa) + 0.5) * height

    if (!add) {
        if (species > 0) {
            pad[2] <- pad[2] + species
        }
        suppressWarnings(blankPlot(width, up, -down, pad, ...))
    }

    if (any(is.na(bot.msa))) {
        plotHelix(bot.helix, flip = TRUE, add = TRUE, y = height/2, ...)
    } else {
        plotCovariance(bot.msa, bot.helix, flip = TRUE, add = TRUE, grid = grid,
            species = species, legend = FALSE, y = -height/2, ...)
    }
    plotCovariance(top.msa, top.helix, add = TRUE, grid = grid,
        species = species, legend = legend, y = height/2, ...)
}

plotCovariance <- function(msa, helix, arcs = TRUE, add = FALSE, grid = FALSE,
        text = FALSE, legend = TRUE, species = 0, base.colour = FALSE, palette =
        NA, flip = FALSE, grid.col = "white", grid.lwd = 0, text.cex = 0.5,
        text.col = "white", text.font = 2, text.family = "sans", species.cex =
        0.5, species.col = "black", species.font = 2, species.family = "mono",
        shape = "circle", conflict.cutoff = 0.01, conflict.lty = 2,
        conflict.col = NA,
        pad = c(0, 0, 0, 0), y = 0, x = 0, ...) {
    if (!is.helix(helix)) {
        stop("Input not a valid helix data frame, aborting")
    }
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    width <- max(nchar(msa))
    height <- ifelse(grid, 1.25, 1)

    if (any(nchar(msa) != width)) {
        warning("WARNING: Padding sequences of unequal length with gaps")
        unequal <- which(nchar(msa) != width)
        for (i in 1:length(unequal)) {
            msa[unequal[i]] <- paste(msa[unequal[i]], paste(rep("-",
                width - nchar(msa[unequal[i]])), collapse = ""), sep = "")
        }
    }

    if (all(is.na(palette))) {
        if (base.colour) {
            palette <- c("#E41A1C", "#4DAF4A", "#FF7F00", "#377EB8", "#BDBDBD",
                "#984EA3")
        } else {
            palette <- c("#00A651", "#0072BC", "#00B9F2", "#F15A22", "#231F20",
                "#AAAAAA", "#DA6FAB")
        }    
    } else {
        if (length(palette) < ifelse(base.colour, 5, 7)) {
            palette <- rep(palette, length.out = ifelse(base.colour, 5, 7))
        }
    }

    if (flip) {
        up <- y
        down <- y - maxHeight(helix) - length(msa) * height
    } else {
        down <- y
        y <- y + length(msa) * height
        up <- maxHeight(helix) + y - ifelse(grid, 0, 1)
    }

    if (!add) {
        if (species > 0) {
            pad[2] <- pad[2] + species
        }
        blankPlot(width, up, down, pad, ...)
    }

    conflict <- NULL
    if (!is.na(conflict.col) || !is.na(conflict.lty)) {
        conflicting <- isConflictingHelix(helix) >= conflict.cutoff
        conflict <- helix[conflicting, ]
        helix <- helix[!conflicting, ]

        if (nrow(conflict) > 0) {
            if (!is.na(conflict.col)) {
                conflict$col <- conflict.col
            }
            if (!is.na(conflict.lty)) {
                conflict$lty <- conflict.lty
            }
        } else {
            conflict <- NULL
        }
    }
    
    if (arcs & nrow(helix) != 0) {
        if (flip) {
            if (!is.null(conflict)) {
                plotHelix(conflict, y = y - (length(msa)) * height, add = TRUE,
                    flip = flip, x = x, ...)
            }
            plotHelix(helix, y = y - (length(msa)) * height, add = TRUE,
                flip = flip, x = x, ...)
        } else {
            if (!is.null(conflict)) {
                plotHelix(conflict, y = y - ifelse(grid, 0, 1), add = TRUE, x = x, ...)
            }
            plotHelix(helix, y = y - ifelse(grid, 0, 1), add = TRUE, x = x, ...)
        }
    }

    if (base.colour) {
        cols <- getBaseColours(msa)    
    } else {
        cols <- getCovarianceColours(msa, expandHelix(helix))
    }

    used <- sort(unique(c(cols)))
    dim <- dim(cols)
    cols <- palette[cols]
    dim(cols) <- dim

    for(i in 1:length(msa)) {
        if (grid) {
            plotCovarianceGrid(x + 1, y - height * i, cols[i, ], height = height,
                border = grid.col, lwd = grid.lwd)
            if (text) {
                plotCovarianceText(x + 1, y - height * i, msa[i], height = height,
                    cex = text.cex, font = text.font, family = text.family,
                    col = text.col)
            }
            if (species > 0) {
                plotCovarianceSpecies(species - x + 1, y - height * i,
                    names(msa[i]), height = height, cex = species.cex,
                    font = species.font, family = species.family,
                    col = species.col)
            }
        } else {
            plotCovarianceLine(x + 1, y - i, cols[i, ])
        }
    }

    if (legend) {
        if (base.colour) {
            text <- c("A", "U", "G", "C", "-", "?")
        } else {
            text <- c("Conservation", "Covariation", "One-sided", "Invalid",
                "Unpaired", "Gap", "Ambiguous")
        }
        legend("bottom", text[used], border = NA, fill = palette[used],
            horiz = TRUE, bty = "n", xpd = NA)
    }    
}

colourByUnknottedGroups <- function(helix, cols, get = TRUE) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting")
    }
    if (missing(cols)) {
        cols <- defaultPalette()
    }
    expanded <- expandHelix(helix)
    group <- as.factor(unknottedGroups(expanded))
    if (length(levels(group)) > length(cols)) {
        warning(paste("Number of groups (", length(levels(group)),
            ") greater than colours (", length(cols) 
            ,"), some groups will be colourless", sep = ""))
    }
    output <- cols[as.integer(group)]
    legend <- table(output)[cols]
    legend[is.na(legend)] <- 0
    if (get) {
        expanded$col <- output
        attr(expanded, "legend") <- paste(legend, "/", sum(legend), sep = "")
        attr(expanded, "fill") <- cols
        return(expanded)
    } else {
        attr(output, "legend") <- paste(legend, "/", sum(legend), sep = "")
        attr(output, "fill") <- cols
        return(output)
    }
}

colourByBasepairFrequency <- function(helix, cols, get = TRUE) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting")
    }
    if (missing(cols)) {
        cols <- rev(defaultPalette())
    }
    freq <- colourByValue(basepairFrequency(helix), cols, get = TRUE)
    if (get) {
        return(freq)
    } else {
        output <- freq$col
        attr(output, "legend") <- attr(freq, "legend")
        attr(output, "fill") <- attr(output, "fill")
        return(output)
    }
}

colourByValue <- function(helix, cols, breaks, get = FALSE, log = FALSE,
    include.lowest = TRUE, ...) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting")
    } else {
        if (nrow(helix) == 0) {
            warning("No helices detected")
            if (get) {
                return(helix)
            } else {
                return(NULL)
            }
        }
        if (all(is.na(helix$value))) {
            stop("Cowardly refusing to deal with NA/NaN values")
        }
    }
    if (missing(cols)) {
        cols <- defaultPalette()
    }

    if (missing(breaks)) {
        breaks <- seq(min(helix$value, na.rm = TRUE),
        max(helix$value, na.rm = TRUE), length.out = length(cols) + 1)
    } else {
        if (length(breaks) == 1 && breaks == 1) {
            breaks <- c(min(helix$value, na.rm = TRUE),
            max(helix$value, na.rm = TRUE))
        }
    }
    if (length(unique(breaks)) == 1) {
        breaks <- c(min(helix$value, na.rm = TRUE) - 1,
        max(helix$value, na.rm = TRUE))
    }

    if (log) {
        test <- helix$value[helix$value > 0]
        start <- logfloor(min(test, na.rm = TRUE))
        end <- logceiling(max(test, na.rm = TRUE))    
        breaks <- c(min(helix$value, na.rm = TRUE), logseq(start, end)[-1])
    }
    levels <- cut(helix$value, breaks = breaks, labels = NULL,
        ordered_result = FALSE, include.lowest = include.lowest, ...)    
    legend <- levels(levels)
    if (length(legend) > length(cols)) {
        warning(paste("Number of intervals (", length(legend),
            ") greater than colours (", length(cols),
            "), some intervals will be colourless", sep = ""))
    }
    fill <- cols[1:length(legend)]
    output <- cols[as.numeric(levels)]    
    attr(output, "legend") <- legend
    attr(output, "fill") <- fill
    if (get) {
        helix$col <- output
        attr(helix, "legend") <- legend
        attr(helix, "fill") <- fill
        return(helix)
    } else {
        return(output)
    }
}

defaultPalette <- function() {
    return(c("#2166AC", "#4393C3", "#92C5DE", "#D1E5F0", "#FDDBC7", "#F4A582", "#D6604D", "#B2182B"))
}

colourByCount <- function(helix, cols, counts, get = FALSE) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data frame, aborting")
    }
    if (missing(cols)) {
        cols <- defaultPalette()
    }
    if (missing(counts)) {
        output <- as.character(cut(seq_len(nrow(helix)), breaks = seq(1,
            nrow(helix), length.out = length(cols) + 1), include.lowest = TRUE,
            labels = cols))
    } else {
        if (length(cols) != length(counts)) {
            stop(paste("Length of counts (", length(counts),
                ") does not match length of cols (", length(cols), ")",
                sep = ""))
        }
        output <- as.character(rep(cols, counts))
    }
    legend <- table(output)[cols]
    legend[is.na(legend)] <- 0
    if (get) {
        helix$col <- NA
        n <- min(length(output), nrow(helix))
        helix$col[1:n] <- output[1:n]
        attr(helix, "legend") <- paste(legend, "/", sum(legend), sep = "")
        attr(helix, "fill") <- cols
        return(helix)
    } else {
        attr(output, "legend") <- paste(legend, "/", sum(legend), sep = "")
        attr(output, "fill") <- cols
        return(output)
    }
}

## Copyright (C) 2011 Daniel Lai and Irmtraud M. Meyer (www.e-rna.org)
## Contact information: irmtraud.meyer@cantab.net

## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

colourByCovariation <- function(helix, msa, cols, get = FALSE) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    output <- colourBy.internal(helixCovariation(helix, msa), 2, -2, cols)
    if (get) {
        helix$col <- output
        attr(helix, "legend") <- attr(output, "legend")
        attr(helix, "fill") <- attr(output, "fill")
        return(helix)
    } else {
        return(output)
    }
}

colourByConservation <- function(helix, msa, cols, get = FALSE) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    output <- colourBy.internal(helixConservation(helix, msa), 1, 0, cols)
    if (get) {
        helix$col <- output
        attr(helix, "legend") <- attr(output, "legend")
        attr(helix, "fill") <- attr(output, "fill")
        return(helix)
    } else {
        return(output)
    }
}

colourByCanonical <- function(helix, msa, cols, get = FALSE) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    output <- colourBy.internal(helixCanonical(helix, msa), 1, 0, cols)
    if (get) {
        helix$col <- output
        attr(helix, "legend") <- attr(output, "legend")
        attr(helix, "fill") <- attr(output, "fill")
        return(helix)
    } else {
        return(output)
    }    
}

colourBy.internal <- function(values, start, end, cols) {
    if (missing(cols)) {
        cols <- defaultPalette()
    }
    cols <- rev(cols)
    seq <- seq(start, end, length.out = length(cols) + 1)
    levels <- cut(values, breaks = seq, include.lowest = TRUE)
    legend <- levels(levels)
    fill <- cols
    output <- cols[as.numeric(levels)]    
    attr(output, "legend") <- legend
    attr(output, "fill") <- fill
    return(output)    
}

# TODO: Three following functions could probably be refactored?
# Given a helix data frame x, returns a list of covariation values corresponding to each row
helixCovariation <- function(helix, msa) {
    if (!is.helix(helix)) {
        stop("Invalid input")
    }
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    ex <- expandHelix(helix)
    num <- rep(1:nrow(helix), times = helix$length)
    cov <- c()
    for (i in 1:nrow(ex)) {
        cov[i] <- basepairCovariation(msa, ex$i[i], ex$j[i])
    }
    pt <- 1
    out = c()
    for (i in 1:nrow(helix)) {
        out[i] <- mean(cov[seq(pt, length.out = helix$length[i])])
        pt <- pt + helix$length[i]
    }
    return(out)
}

# Given a helix data frame x, returns a list of covariation values corresponding to each row
helixConservation <- function(helix, msa) {
    if (!is.helix(helix)) {
        stop("Invalid input")
    }
    if (nrow(helix) == 0) {
        return(0)
    }
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    ex <- expandHelix(helix)
    num <- rep(1:nrow(helix), times = helix$length)
    cons <- c()
    for (i in 1:nrow(ex)) {
        cons[i] <- basepairConservation(msa, ex$i[i], ex$j[i])
    }
    pt <- 1
    out = c()
    for (i in 1:nrow(helix)) {
        out[i] <- mean(cons[seq(pt, length.out = helix$length[i])])
        pt <- pt + helix$length[i]
    }
    return(out)
}

helixCanonical <- function(helix, msa) {
    if (!is.helix(helix)) {
        stop("Invalid input")
    }
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    ex <- expandHelix(helix)
    num <- rep(1:nrow(helix), times = helix$length)
    cano <- c()
    for (i in 1:nrow(ex)) {
        cano[i] <- basepairCanonical(msa, ex$i[i], ex$j[i])
    }
    pt <- 1

    out = c()
    for (i in 1:nrow(helix)) {
        out[i] <- mean(cano[seq(pt, length.out = helix$length[i])])
        pt <- pt + helix$length[i]
    }
    return(out)
}

# Given a multiple sequence alignment, and two column indices indicating the 5' partner, and 3' partner respectively,
# calculates the covariation of a base pair at this position.
# values ranges between -2 and 2
basepairCovariation <- function(msa, pos.5p, pos.3p) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    covariation <- 0
    seq.pair.count <- choose(length(msa), 2)
    base.pairs <- paste(substr(msa, pos.5p, pos.5p),
        substr(msa, pos.3p, pos.3p), sep="")

    pair.counts <- table(base.pairs)
    pair.names <- names(pair.counts)

    if (length(pair.counts) <= 1) {
        return(0)
    }

    for (pairA in 2:length(pair.counts)) {
        for (pairB in 1:(pairA-1)) {
            bpA <- pair.names[pairA]
            bpB <- pair.names[pairB]
            occurences <- pair.counts[pairA] * pair.counts[pairB]
            hdist <- hamming(bpA, bpB)
            coef <- ifelse(isValidBp(bpA) & isValidBp(bpB), 1, -1)
            covariation <- covariation + (coef * hdist * occurences)
        }
    }
    return (covariation / seq.pair.count)
}

# returns the hamming distance between strings s1 and s2
# hamming distance = number of positions which differ between s1 and s2
# ASSUMES same length
hamming <- function(s1, s2) {
    return(sum(strsplit(s1, "")[[1]] != strsplit(s2, "")[[1]]))
}

isValidBp <- function(bp) {
    return(toupper(bp) %in% c("GC", "CG", "UA", "AU", "GU", "UG", "TA", "AT", "TG", "GT"))
}

basepairConservation <- function(msa, pos.5p, pos.3p) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    return((baseConservation(msa, pos.5p) + baseConservation(msa, pos.3p)) / 2)    
}

baseConservation <- function(msa, pos) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    return(columnPercentIdentity(substr(msa, pos, pos)))
}

basepairCanonical <- function(msa, pos.5p, pos.3p) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    base.pairs <- paste(substr(msa, pos.5p, pos.5p), substr(msa, pos.3p, pos.3p), sep="")
    canonical.count <- 0
    for (bp in base.pairs) {
        if (isValidBp(bp)) {
            canonical.count <- canonical.count + 1
        }
    }
    return(canonical.count/length(base.pairs))
}

# linear implementation of column percent identity
# does not work... cannot correctly apply denominator
columnPercentIdentity <- function(bases) {
    identities <- 0
    seq.pair.count <- choose(length(bases), 2)

    base.counts <- table(bases)
    base.names <- names(base.counts)

    if (sum(base.counts) != length(bases)) {
        warning("columnPercentIdentity: length of column does not equal sum(base count)")
    }

    num.gap.pairs <- 0
    for (base.idx in 1:length(base.counts)) {
        count <- base.counts[base.idx]
        base <- base.names[base.idx]
        if (base == "-") {
            num.gap.pairs <- choose(count, 2)
        } else {
            identities <- identities + choose(count, 2)
        }
    }
    return(identities / (seq.pair.count - num.gap.pairs))
}

# given a multiple sequence alignment, and a helix data structure,
# this function returns the covariation of the entire alignment.
# the formula used is described on pg. 86 of Nick Wiebe's MSc thesis
alignmentCovariation <- function(msa, helix) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    if (any(helix$length != 1)) {
        helix <- expandHelix(helix)
    }
    covariation <- sum(apply(helix, 1, function(bp, msa) {
            basepairCovariation(msa, bp['i'], bp['j'])
        }, msa))
    return (covariation/nrow(helix))
}

# calculates average percent identity of all possible pairs of sequences in the alignment
# percent identity is equal to number of non-gap matches / number of non-gap columns
# definition of percent identity: average over all seq pairs (# identities / (aligned positions + internal gaps))
alignmentConservation <- function(msa) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    seq.pair.count <- choose(length(msa), 2)
    pid.sum <- 0
    msa.bases <- strsplit(msa, "")
    for (seqB.index in 2:length(msa)) {
        for (seqA.index in 1:(seqB.index-1)) {
            seqA.bases <- msa.bases[[seqA.index]]
            seqB.bases <- msa.bases[[seqB.index]]
            alignedPositions <- which(seqA.bases != "-" & seqB.bases != "-")
            if (length(alignedPositions) == 0) { next }
            start <- min(alignedPositions)
            end <- max(alignedPositions)
            seqA.bases <- seqA.bases[start:end]
            seqB.bases <- seqB.bases[start:end]
            contains.nucleotide <- which(seqA.bases != "-" | seqB.bases != "-")
            seqA.cleaned <- seqA.bases[contains.nucleotide]
            seqB.cleaned <- seqB.bases[contains.nucleotide]
            identities <- sum(seqA.cleaned == seqB.cleaned)
            pid.sum <- pid.sum + identities/length(seqA.cleaned)
        }
    }
    return (pid.sum/seq.pair.count)
}

# calculates percent of base pairs that are canonical (GC, CG, AU, UA, GU, UG) in the alignment
alignmentCanonical <- function(msa, helix) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    if (any(helix$length != 1)) {
        helix <- expandHelix(helix)
    }
    if (nrow(helix) == 0) {
        return(0)
    }
    percentCanonical <- 0
    for (bp.num in 1:nrow(helix)) {
        bp.i <- helix[bp.num, 'i']
        bp.j <- helix[bp.num, 'j']
        percentCanonical <- percentCanonical +
            basepairCanonical(msa, bp.i, bp.j)
    }
    return(percentCanonical / nrow(helix))
}

structureMismatchScore <- function(msa, helix, one.gap.penalty = 2,
    two.gap.penalty = 2, invalid.penalty = 1) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    if (!is.helix(helix)) {
        stop("Invalid helix data.frame")
    } else {
        helix <- expandHelix(helix)
    }
    return(unlist(lapply(msa, structureMismatchScoreInternal, helix,
        one.gap.penalty, two.gap.penalty, invalid.penalty)))
}

structureMismatchScoreInternal <- function(sequence, helix, one.gap.penalty = 2,
    two.gap.penalty = 2, invalid.penalty = 1) {
    base.5p <- substring(sequence, helix$i, helix$i)
    base.3p <- substring(sequence, helix$j, helix$j)
    gaps.5p <- base.5p == "-"
    gaps.3p <- base.3p == "-"
    one.sided.gap <- xor(gaps.5p, gaps.3p)
    two.sided.gap <- gaps.5p & gaps.3p
    invalid.pair <- !isValidBp(paste(base.5p, base.3p, sep = ""))
    non.canonical.pair <- invalid.pair & !(one.sided.gap | two.sided.gap)
    return(c(one.gap.penalty * length(which(one.sided.gap))
        + two.gap.penalty * length(which(two.sided.gap))
        + invalid.penalty * length(which(non.canonical.pair))))
}

alignmentPercentGaps <- function(msa) {
    if (is(msa, "XStringSet")) {
        msa <- as.character(msa)
    }
    return(unlist(lapply(lapply(strsplit(msa, ""), '==', '-'), sum)) / nchar(msa))
}

### R code from vignette source 'R4RNA.Rnw'

###################################################
### code chunk number 1: R4RNA.Rnw:40-54
###################################################
library(R4RNA)

message("TRANSAT prediction in helix format")
transat_file <- system.file("extdata", "helix.txt", package = "R4RNA")
transat <- readHelix(transat_file)

message("RFAM structure in dot bracket format")
known_file <- system.file("extdata", "vienna.txt", package = "R4RNA")
known <- readVienna(known_file)

message("Work with basepairs instead of helices for more flexibility")
message("Breaks all helices into helices of length 1")
transat <- expandHelix(transat)
known <- expandHelix(known)


###################################################
### code chunk number 2: R4RNA.Rnw:63-65
###################################################
plotHelix(known, line = TRUE, arrow = TRUE)
mtext("Known Structure", side = 3, line = -2, adj = 0)


###################################################
### code chunk number 3: R4RNA.Rnw:73-76
###################################################
plotDoubleHelix(transat, known, line = TRUE, arrow = TRUE)
mtext("TRANSAT\nPredicted\nStructure", side = 3, line = -5, adj = 0)
mtext("Known Structure", side = 1, line = -2, adj = 0)


###################################################
### code chunk number 4: R4RNA.Rnw:84-86
###################################################
message("Filter out helices above a certain p-value")
transat <- transat[which(transat$value <= 1e-3), ]


###################################################
### code chunk number 5: R4RNA.Rnw:92-100
###################################################
message("Assign colour to basepairs according to p-value")
transat$col <- col <- colourByValue(transat, log = TRUE)

message("Coloured encoded in 'col' column of transat structure")
plotDoubleHelix(transat, known, line = TRUE, arrow = TRUE)

legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.05, bty = "n", border = NA, cex = 0.75, title = "TRANSAT P-values")


###################################################
### code chunk number 6: R4RNA.Rnw:112-113
###################################################
plotOverlapHelix(transat, known, line = TRUE, arrow = TRUE, scale = FALSE)


###################################################
### code chunk number 7: R4RNA.Rnw:130-137
###################################################
message("Multiple sequence alignment of interest")
library(Biostrings)
fasta_file <- system.file("extdata", "fasta.txt", package = "R4RNA")
fasta <- as.character(readBStringSet(fasta_file))

message("Plot covariance in alignment")
plotCovariance(fasta, known, cex = 0.5)


###################################################
### code chunk number 8: R4RNA.Rnw:147-148
###################################################
plotCovariance(fasta, transat, cex = 0.5, conflict.col = "grey")


###################################################
### code chunk number 9: R4RNA.Rnw:158-162
###################################################
col <- colourByCovariation(known, fasta, get = TRUE)
plotCovariance(fasta, col, grid = TRUE, legend = FALSE)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.1, bty = "n", border = NA, cex = 0.37, title = "Covariation")


###################################################
### code chunk number 10: R4RNA.Rnw:168-173
###################################################
custom_colours <- c("green", "blue", "cyan", "red", "black", "grey")
plotCovariance(fasta, col <- colourByConservation(known, fasta, get = TRUE),
    palette = custom_colours, cex = 0.5)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.15, bty = "n", border = NA, cex = 0.75, title = "Conservation")


###################################################
### code chunk number 11: R4RNA.Rnw:178-182
###################################################
col <- colourByCanonical(known, fasta, custom_colours, get = TRUE)
plotCovariance(fasta, col, base.colour = TRUE, cex = 0.5)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.15, bty = "n", border = NA, cex = 0.75, title = "% Canonical")


###################################################
### code chunk number 12: R4RNA.Rnw:187-189
###################################################
col <- colourByUnknottedGroups(known, c("red", "blue"), get = TRUE)
plotCovariance(fasta, col, base.colour = TRUE, legend = FALSE, species = 23, grid = TRUE, text = TRUE, text.cex = 0.2, cex = 0.5)


###################################################
### code chunk number 13: R4RNA.Rnw:197-199
###################################################
toLatex(sessionInfo())

## Copyright (C) 2011 Daniel Lai and Irmtraud M. Meyer (www.e-rna.org)
## Contact information: irmtraud.meyer@cantab.net

## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

writeHelix <- function(helix, file = stdout()) {
    if (!is.helix(helix)) {
        warning("Data frame not a compliant helix, reformatting...")
        helix <- as.helix(helix, attr(helix, "length"))
    } 
    writeLines(paste("#", attr(helix, "length")), file)
    suppressWarnings(write.table(helix, file, quote = FALSE, row.names = FALSE,
        sep = "\t", append = TRUE))
}

emptyHelix <- function(seq.length) {
    return (as.helix(data.frame(i=vector(), j=vector(), length=vector(),
        value=vector()), seq.length))
}

readConnect <- function(file) {
    con <- openFileOrConnection(file)
    on.exit(close(con))
    seq.length <- NULL
    while(length(header <- readLines(con, n = 1)) > 0) {
        width <- strsplit(header, "\\s+")[[1]]
        width <- width[which(width != "")]
        if (length(width) == 0) { 
            next 
        }
        seq.length <- as.numeric(width[1])
        if (is.na(seq.length)) {
            stop("ReadConnect: Structure length missing in header of connect file")
        }
        energy <- regexpr("(ENERGY|dG)\\s*=?\\s*\\S*", header, ignore.case = TRUE)
        energy <- substr(header, energy, energy + attr(energy, "match.length") - 1)
        energy <- sub("(ENERGY|dG)\\s*=?\\s*", "", energy, ignore.case = TRUE)
        energy <- as.numeric(energy)
        break
    }

    table <- read.delim(con, header = FALSE, nrows = seq.length, sep = "")
    if (ncol(table) != 6) {
        print(ncol(table))
        print(table)
        stop("ReadConnect: Requires 6 data columns in connect format, aborting.")
    }
    helix <- table[which(table[, 5] != 0), c(1, 5)]
    if (nrow(helix) == 0) {
        return (emptyHelix(seq.length))
    }
    names(helix) <- c("i", "j")
    helix$length <- 1L
    helix$value <- energy
    helix <- helix[which(helix$j > helix$i), ]

    return(as.helix(helix, seq.length))
}

readBpseq <- function(file) {
    con <- openFileOrConnection(file)
    on.exit(close(con))
    lines <- readLines(con)    
    
    file_line <- lines[grep("^Filename", lines, ignore.case = TRUE)]
    organism_line <- lines[grep("^Organism", lines, ignore.case = TRUE)]
    accession_line <- lines[grep("^Accession", lines, ignore.case = TRUE)]
    bps <- lines[grep("^\\d+", lines)]
    cells <- strsplit(bps, "\\s+")

    if (unique(unlist(lapply(cells, length))) != 3) {
        stop("Expecting three column data in BPSEQ format")
    }

    matrix <- data.frame(matrix(unlist(cells), ncol = 3, byrow = TRUE))    
    i <- as.integer(as.character(matrix[, 1]))
    j <- as.integer(as.character(matrix[, 3]))
    width <- max(i, na.rm = TRUE)
    seq <- paste(matrix[1:width, 2], collapse = "")
    filename <- unlist(strsplit(file_line[1], ":\\s*"))[2]
    organism <- unlist(strsplit(organism_line[1], ":\\s*"))[2]
    accession <- unlist(strsplit(accession_line[1], ":\\s*"))[2]

    subset <- which(i < j)
    helix <- data.frame(i = i[subset], j = j[subset], length = 1L, value = NA)

    attr(helix, "organism") <- organism;
    attr(helix, "sequence") <- seq;
    attr(helix, "accession") <- accession;
    attr(helix, "filename") <- filename;
    return(as.helix(helix, width));
}

readHelix <- function(file) {
    file <- openFileOrConnection(file)
    on.exit(close(file))

    width <- strsplit(sub("#(\\s*)", "", readLines(file, n = 1)), "\\s")[[1]][1]
    width <- as.numeric(width)
        
    input <- read.delim(file, header = TRUE, stringsAsFactors = FALSE)
    colnames(input)[1:4] <- c("i", "j", "length", "value")
    
    max <- max(input$i, input$j, na.rm = TRUE)
    if (is.na(width)) {
        warning("Could not read valid length, using maximum position instead.")
        width <- max
    }
    if (width < max) {
        warning("Changing length to maximum basepair position.")
    }

    return(as.helix(input, width))
}

# If you're using FASTA, line-wrap is okay, if not (i.e. RNA mafia output), don't line-wrap
readVienna <- function(file, palette = NA) {
    if (length(grep("^>", readLines(file, n = 1))) == 1) {
        lines <- as.character(readBStringSet(file))
    } else {
        lines <- readLines(file)
    }
    # lines will NOT be line wrapped anymore, ASSUME NOT LINEWRAPPING!
    if (length(lines) == 0) {
        return (emptyHelix(NA))
    }
    name <- ""
    if (length(names(lines)) > 0) {
        name <- names(lines)[1];
    }

    raw <- lines[grep('[(].*[)]|<.*>|[[].*[]]|[{].*[}]', lines)]
    raw <- sub("\\(\\s+\\-", "(-", raw) # Hack to parse more energy values
    split <- strsplit(raw, "\\s")
    struct <- unlist(lapply(split, "[", 1))
    val <- unlist(lapply(split, "[", 2))
    seq <- ""

    length <- nchar(struct)
    halve <- grep("G|U", struct, ignore.case = TRUE)
    if (length(halve) > 0) {
        seq <- substr(struct[halve], 1, length/2);
    }

    struct[halve] <- substr(struct[halve], (length / 2) + 1, length)
    length <- nchar(struct)
    
    output <- data.frame()
    for (i in 1:length(struct)) {
        helix <- viennaToHelix(struct[i], val[i], palette = palette)
        output <- rbind(output, helix)
    }
    attr(output, "sequence") <- seq;
    attr(output, "name") <- name;
    return(as.helix(output, max(length)))
}

openFileOrConnection <- function(file, mode = "r") {
    if (is.character(file)) {
        file <- file(file, mode)
    }
    else {
        if (!inherits(file, "connection")) 
            stop("'file' must be a character string or connection")
        if (!isOpen(file)) {
            open(file, mode)
        }
    }
    return(file)    
}

viennaToHelix <- function(vienna, value = NA, palette = NA) {
    test <- regexpr("\\-?(\\d+\\.?\\d*|\\d*\\.?\\d+)", value)
    if (!is.na(test) & test != -1) {
        value <- as.numeric(substr(value, test,
            test + attr(test, "match.length") - 1))
    } else {
        value <- NA
    }
    brackets <- c('(' = ')', '<' = '>', '[' = ']', '{' = '}',
        'A' = 'a', 'B' = 'b', 'C' = 'c', 'D' = 'd')
    stacks <- list(')' = c(), '>' = c(), ']' = c(), '}' = c(),
        'a' = c(), 'b' = c(), 'c' = c(), 'd' = c())
    pairs <- c()
    valids <- c('(', ')', '<', '>', '[', ']', '{', '}', 'A',
        'a', 'B', 'b', 'C', 'c', 'D', 'd', '.', '-')
    chars <- unlist(strsplit(vienna, ""))
    chars <- chars[which(chars %in% valids)]
    chars[which(chars == '-')] <- '.';
    if (nchar(vienna) != length(chars)) {
        warning("Removed invalid character from input string")
    }
    if (all(chars == ".")) {
        return(emptyHelix(length(chars)))
    }

    output <- data.frame()
    for (j in 1:length(chars)) {
        char <- chars[j]
        if (char != '.') {
            if (!is.na(brackets[char])) {
                stacks[[brackets[char]]] <- append(stacks[[brackets[char]]], j)
            } else {
                if (!is.na(stacks[char]) && length(stacks[char]) > 0) {
                    end <- length(stacks[[char]])
                    partner <- stacks[[char]][end]
                    if (length(partner) == 0) {
                        stop(paste("Unbalanced", char,
                            "bracket at position", j))
                    }
                    output <- rbind(output, c(partner, j, 1, value,
                        which(brackets == char)))
                    stacks[[char]] <- stacks[[char]][-end]
                } else {
                    stop(paste("Unrecognized symbol", char,
                        "in position", j))
                }
            }
        }
    }
    for (i in 1:length(brackets)) {
        if (length(stacks[[brackets[i]]]) > 0) {
            stop(paste("Unable to find closing partners for all",
                "entries for symbol", names(brackets[i]), "-", brackets[i]))
        }
    }
    
    output <- output[order(output[, 1]), ]
    col <- output[, 5]
    output <- output[, -5]
    output <- as.helix(output, length(chars))    
    rownames(output) <- NULL

    if (!all(is.na(palette))) {
        palette <- rep(palette, length.out = 8)
        output$col <- palette[col]
    }

    return(output);
}

# Takes in a helix data structure and returns the corresponding structure
# Will allow up to 8 levels of pseudo-knots, and will REMOVE all conflicting
# basepairs, both done in a greedy fashion.
helixToVienna <- function(helix) {
    if(!is.helix(helix)) {
        stop("Invalid input detected, aborting")
    }
    if (any(helix$length > 1)) {
        warning("Expanding helix to basepairs")
        helix <- expandHelix(helix)
    }
    conflict <- isConflictingHelix(helix)
    if (any(conflict)) {
        warning("Removing conflicting basepairs")
        helix <- helix[!conflict, ]
    }
    if (nrow(helix) == 0) {
        stop("No basepairs in helix")
    }
    
    lbrac <- c("(", "<", "{", "[", "A", "B", "C", "D")
    rbrac <- c(")", ">", "}", "]", "a", "b", "c", "d")
    
    group <- unknottedGroups(helix)
    if (max(group) > length(lbrac)) {
        warning("Too much pseudoknots! Only returning first 8 levels")
    }
    str <- rep(".", attr(helix, "length"))
    for(i in 1:min(length(lbrac), max(group))) {
        str[helix$i[which(group == i)]] <- lbrac[i]
        str[helix$j[which(group == i)]] <- rbrac[i]
    }    
    return(paste(str, collapse = ""))
}

# TODO: test with conflicting basepairs
helixToBpseq <- function(helix) {
    if (!is.helix(helix)) {
        stop("Not a valid helix data.frame, aborting")
    }
    if (is.null(attr(helix, "sequence"))) {
        stop("Missing nucleotide sequence, aborting")
    }
    output <- data.frame(i = as.integer(1:attr(helix, "length")),
        base = unlist(strsplit(attr(helix, "sequence"), "")))
    expand <- expandHelix(helix)[, c("i", "j")]
    output <- merge(output, expand, all = TRUE)
    output$j[is.na(output$j)] <- 0
    return(output)
}

helixToConnect <- function(helix) {
    bpseq <- helixToBpseq(helix)
    output <- data.frame(i = bpseq$i, base = bpseq$base, left = bpseq$i - 1,
        right = bpseq$i + 1, j = bpseq$j, same = bpseq$i)
    return(output)
}

% \VignetteIndexEntry{R4RNA}
% \VignetteDepends{R4RNA}
% \VignetteKeywords{RNA secondary structure arc diagram visualization}
% \VignettePackage{R4RNA}

\documentclass[letterpaper]{article}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{fullpage}
\usepackage{hyperref}
\usepackage{caption}

\title{R4RNA: A R package for RNA visualization and analysis}
\author{Daniel Lai}
\date{\today}

\begin{document}

\setkeys{Gin}{width=\textwidth}

\maketitle
\tableofcontents

\section{R4RNA}

The R4RNA package aims to be a general framework for the analysis of RNA
secondary structure and comparative analysis in R, the language so chosen due
to its native support for publication-quality graphics, and portability across
all major operating systems, and interactive power with large datasets.

To demonstrate the ease of creating complex arc diagrams, a short example is
as follows.

\subsection{Reading Input}

Currently, supported input formats include dot-bracket, connect, bpseq, and a
custom ``helix'' format.  Below, we read in a structure predicted by TRANSAT,
the known structure obtained form the RFAM database.

<<>>=
library(R4RNA)

message("TRANSAT prediction in helix format")
transat_file <- system.file("extdata", "helix.txt", package = "R4RNA")
transat <- readHelix(transat_file)

message("RFAM structure in dot bracket format")
known_file <- system.file("extdata", "vienna.txt", package = "R4RNA")
known <- readVienna(known_file)

message("Work with basepairs instead of helices for more flexibility")
message("Breaks all helices into helices of length 1")
transat <- expandHelix(transat)
known <- expandHelix(known)
@

\subsection{Basic Arc Diagram}

The standard arc diagram, where the nucleotide sequence is the horizontal
line running left to right from 5' to 3' at the bottom of the diagram.  Any
two bases that base-pair in a secondary structure are connect with an arc.

<<fig=TRUE,eps=FALSE,height=1.9>>=
plotHelix(known, line = TRUE, arrow = TRUE)
mtext("Known Structure", side = 3, line = -2, adj = 0)
@

\subsection{Multiple Structures}

Two structures for the same sequence can be visualized simultaneously, allowing
one to compare and contrast the two structures.

<<fig=TRUE,eps=FALSE,height=4>>=
plotDoubleHelix(transat, known, line = TRUE, arrow = TRUE)
mtext("TRANSAT\nPredicted\nStructure", side = 3, line = -5, adj = 0)
mtext("Known Structure", side = 1, line = -2, adj = 0)
@

\subsection{Filtering Helices}
Base-pairs can be associated with a value, such as energy stability or
statistical probability, and we can easily filter out basepairs according to
such rules.

<<>>=
message("Filter out helices above a certain p-value")
transat <- transat[which(transat$value <= 1e-3), ]
@

\subsection{Colouring Structures}
We can also assign colour to the structure according to base-pairs values.

<<fig=TRUE,eps=FALSE,height=4.3>>=
message("Assign colour to basepairs according to p-value")
transat$col <- col <- colourByValue(transat, log = TRUE)

message("Coloured encoded in 'col' column of transat structure")
plotDoubleHelix(transat, known, line = TRUE, arrow = TRUE)

legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.05, bty = "n", border = NA, cex = 0.75, title = "TRANSAT P-values")
@

\subsection{Overlapping Multiple Structures}

A neat way of visualizing the concordance between two structure is an
overlapping structure diagram, which we can use to overlap the predicted TRANSAT
structure and the known RFAM structure.  Predicted basepairs that exist in the
known structure are drawn above the line, and those predicted that are not known
to exist are drawn below.  Those known but unpredicted are shown in black above
the line.

<<fig=TRUE,eps=FALSE,height=4.4>>=
plotOverlapHelix(transat, known, line = TRUE, arrow = TRUE, scale = FALSE)
@

\subsection{Visualizing Multiple Sequence Alignments}

In addition to visualizing the structure alone, we can also visualize a
secondary structure along with aligned nucleotide sequences.  In the following,
we will read in a multiple sequence alignment obtained from RFAM, and visualize
the known structure on top of it.

We can also annotate the alignment colours according to their agreement with the
known structure.  If a sequence can form as basepair as dictated by the structure,
the basepair is coloured green, else red.  For green basepairs, if a mutation
has occured, but basepairing potential is retained, it is coloured in blue
(dark for mutations in both bases, light for single-sided mutation).  Unpaired
bases are in black and gaps are in grey.

<<fig=TRUE,eps=FALSE,height=2.4>>=
message("Multiple sequence alignment of interest")
library(Biostrings)
fasta_file <- system.file("extdata", "fasta.txt", package = "R4RNA")
fasta <- as.character(readBStringSet(fasta_file))

message("Plot covariance in alignment")
plotCovariance(fasta, known, cex = 0.5)
@

\subsection{Multiple Sequence Alignements with Annotated Arcs}

Arcs can be coloured as usual.  It should be noted that structures with
conflicting basepairs (arcs sharing a base) cannot be visualized properly
on a multiple sequence alignment, and are typically filtered out (\textit{e.g.}
drawn in grey here).

<<fig=TRUE,eps=FALSE,height=2.7>>=
plotCovariance(fasta, transat, cex = 0.5, conflict.col = "grey")
@

\subsection{Additional Colouring Methods}

Various other methods of colour arcs exist, along with many options to control
appearances:

\subsubsection{Colour By Covariation (with alignment as blocks)}

<<fig=TRUE,eps=FALSE,height=2.4>>=
col <- colourByCovariation(known, fasta, get = TRUE)
plotCovariance(fasta, col, grid = TRUE, legend = FALSE)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.1, bty = "n", border = NA, cex = 0.37, title = "Covariation")
@


\subsubsection{Colour By Conservation (with custom alignment colours)}

<<fig=TRUE,eps=FALSE,height=2.2>>=
custom_colours <- c("green", "blue", "cyan", "red", "black", "grey")
plotCovariance(fasta, col <- colourByConservation(known, fasta, get = TRUE),
    palette = custom_colours, cex = 0.5)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.15, bty = "n", border = NA, cex = 0.75, title = "Conservation")
@

\subsubsection{Colour By Percentage Canonical Basepairs (with custom arc colours)}

<<fig=TRUE,eps=FALSE,height=2.2>>=
col <- colourByCanonical(known, fasta, custom_colours, get = TRUE)
plotCovariance(fasta, col, base.colour = TRUE, cex = 0.5)
legend("topright", legend = attr(col, "legend"), fill = attr(col, "fill"),
    inset = 0.15, bty = "n", border = NA, cex = 0.75, title = "% Canonical")
@

\subsubsection{Colour Pseudoknots (with CLUSTALX-style alignment)}

<<fig=TRUE,eps=FALSE,height=2.2>>=
col <- colourByUnknottedGroups(known, c("red", "blue"), get = TRUE)
plotCovariance(fasta, col, base.colour = TRUE, legend = FALSE, species = 23, grid = TRUE, text = TRUE, text.cex = 0.2, cex = 0.5)
@


\section{Session Information}

The version number of R and packages loaded for generating the vignette were:

<<echo=FALSE, results=tex>>=
toLatex(sessionInfo())

@

\end{document}

\name{Convert Helix Formats}
\alias{viennaToHelix}
\alias{helixToVienna}
\alias{helixToConnect}
\alias{helixToBpseq}
\title{
    Convert helix structures to and from other formats
}
\description{
    Converts dot bracket vienna format to and from helix format.  It should be
    noted that the allows structures of vienna is a subset of those allowed
    in the helix format.  Thus, conversion from vienna to helix will yield the
    identical structure, while conversion from helix to vienna may result in the
    loss of certain basepairs (mainly those that are conflicting).  Pseudoknots
    are supported in both directions of conversion with limitations.
}
\usage{
    viennaToHelix(vienna, value = NA, palette = NA)
    helixToVienna(helix)
    helixToConnect(helix)
    helixToBpseq(helix)
}
\arguments{
    \item{vienna}{
        A string containing \emph{only} a vienna dot bracket structure, with
        balanced brackets.  Allowable brackets are (, <, [, \{, A, B, C, and D
        (where upper-case alphabets are paired with lower-case alphabets).
    }
    \item{value}{
        A numerical value to assign to all helices.
    }
    \item{palette}{
        A list of colour names for up to 8 colours that will be used to colour
        brackets of type (, <, [, \{, A, B, C, and D, respectively.
    }
    \item{helix}{
        A helix data.frame.
    }
}
\details{
    \code{viennaToHelix} will ignore any non dot-bracket characters prior
    to parsing, so the resultant length will be shorter than expected if invalid
    characters are included.

    If the colour palette is less than the number of supported brackets, it
    will simply cycle through the list.  To explicitly prevent the colouring/
    display of specific bracket type, colour it \dQuote{NA}.

    For \code{helixToVienna}, pseudoknotted basepairs will be assigned
    different bracket types.  As there are only 8 supported bracket types,
    any basepair pseudonotted deeper than 8 levels will be excluded from the
    output.  Additionally, vienna format is unable to respresent conflicting
    basepairs, so conflicting basepairs will also be excluded.  For both types
    of exclusion, those at the bottom of the helix data.frame will always be
    excluded in favour of keeping helices higher on the data.frame table.    

    \code{helixToConnect} and \code{helixToBpseq} will convert a
    \emph{non-conflicting} helix data.frame into connect or bpseq format
    repsectively, provided the helix structure has a \dQuote{sequence} attribute
    containing a single nucleotide sequence of the structure.
}
\value{
    \code{viennaToHelix} returns a helix data.frame.  \code{helixToVienna}
    returns a character string of basepairs in the Vienna helix format.
    \code{helixToConnect} and \code{HelixTpBpseq} return data.frames in the
    connect and bpseq formats, respectively.
}
\author{
    Daniel Lai
}
\examples{
    # viennaToHelix demonstrating ALL valid bracket symbols
    dot_bracket <- ".....(<[{.....ABCD.....}]>).....dcba....."
    parsed <- viennaToHelix(dot_bracket, -31.5)
    print(parsed)

    vienna <- helixToVienna(parsed)
    print(vienna)

    # Colouring the brackets by bracket type
    colour <- c("red", "orange", "yellow", "green", "lightblue", "blue", "purple", "black")
    double.rainbow <- viennaToHelix(dot_bracket, 0, colour)
    plotHelix(double.rainbow)
}
\keyword{manip}

\name{R4RNA-package}
\alias{R4RNA}
\alias{R4RNA-package}
\docType{package}
\title{
    An R package for RNA visualization and analysis
}
\description{
    An R package for RNA visualization and analysis
}
\keyword{package}
\examples{
    # Read input data
    predicted <- readHelix(system.file("extdata", "helix.txt", package = "R4RNA"))
    known <- readVienna(system.file("extdata", "vienna.txt", package = "R4RNA"))
    sequence <- as.character(readBStringSet(system.file("extdata", "fasta.txt", package = "R4RNA")))

    plotHelix(predicted)
    pval.coloured <- colourByValue(predicted, log = TRUE, get = TRUE)
    plotDoubleHelix(pval.coloured, known, scale = FALSE)
    plotOverlapHelix(pval.coloured, known)

    cov.coloured <- colourByCovariation(known, sequence, get = TRUE)
    plotCovariance(sequence, cov.coloured)
    
    plotDoubleCovariance(cov.coloured, pval.coloured, sequence,
        conflict.filter = "grey")
    plotOverlapCovariance(pval.coloured, known, sequence, grid = TRUE,
        conflict.filter = "grey", legend = FALSE, any = TRUE)

    # List of all functions
    ls("package:R4RNA")
    # use example() and help() for more details on each function
}

\name{Find Unknotted Groups}
\alias{unknottedGroups}
\title{
    Partition basepairs into unknotted groups
}
\description{
    Breaks down input helices into basepairs, and assigns each basepair to a
    numbered group such that basepairs in each group are non-pseudoknotted
    relative to all other basepairs within the same group.

    The algorithm is greedy and thus will \emph{not} find the best combination
    of basepairs to minimize the number of groups.
}
\usage{
    unknottedGroups(helix) 
}
\arguments{
    \item{helix}{
        A helix data.frame.
    }
}
\value{
    An array of integers dictating the groups of each helix.  Will only
    correspond to the input helix structure if the input had helices of length 1
    (e.g. output of \code{\link{expandHelix}}).
}
\seealso{
    \code{\link{colourByUnknottedGroups}}

    \code{\link{expandHelix}}
}
\author{
    Daniel Lai
}
\examples{
    data(helix)
    known$group <- unknottedGroups(known)
    print(known)
}
\keyword{aplot}

\name{Covariation Plots}
\alias{plotCovariance}
\alias{plotDoubleCovariance}
\alias{plotOverlapCovariance}

\title{
    Plot nucleotide sequence coloured by covariance
}
\description{
    Given a multiple sequence alignment and a corresponding secondary structure,
    nucleotides in the sequence alignment will be coloured according to the
    basepairing and conservation status, where green is the most commonly
    observed valid basepair in the column, dark blue being valid covariation
    (i.e. mutation into another valid basepair), cyan is one-sided mutation that
    retains the basepair, and red is a mutation where the basepair has been
    lost.
}
\usage{
    plotCovariance(msa, helix, arcs = TRUE, add = FALSE, grid = FALSE, text =
        FALSE, legend = TRUE, species = 0, base.colour = FALSE, palette = NA, flip =
        FALSE, grid.col = "white", grid.lwd = 0, text.cex = 0.5, text.col = "white",
        text.font = 2, text.family = "sans", species.cex = 0.5, species.col = "black",
        species.font = 2, species.family = "mono", shape = "circle", conflict.cutoff =
        0.01, conflict.lty = 2, conflict.col = NA, pad = c(0, 0, 0, 0), y = 0, x = 0,
        ...)
    plotDoubleCovariance(top.helix, bot.helix, top.msa, bot.msa = top.msa,
        add = FALSE, grid = FALSE, species = 0, legend = TRUE,
        pad = c(0, 0, 0, 0), ...)
    plotOverlapCovariance(predict.helix, known.helix, msa, bot.msa = TRUE,
        overlap.cutoff = 1, miss = "black", add = FALSE, grid = FALSE, species = 0,
        legend = TRUE, pad = c(0, 0, 0, 0), ...)
}
\arguments{
    \item{msa, top.msa, bot.msa}{
        A multiple sequence alignment.  Can be either a \code{Biostrings}
        \code{XStringSet} object or a named array of strings like ones obtained
        from converting XStringSet with \code{as.character}.

        \code{top.msa} and \code{bot.msa} are specific to \code{top.helix} and
        \code{bot.helix} respectively, and may be set to NA to have no
        multiple sequence alignment at all.
    }
    \item{helix, top.helix, bot.helix, predict.helix, known.helix}{
        A helix data.frame with a structure corresponding to \code{msa},

        See \code{\link{plotDoubleHelix}} and \code{\link{plotOverlapHelix}} for
        detailed explanations of \code{top.helix}, \code{bot.helix},
        \code{predict.helix}, and \code{known.helix}.
    }
    \item{arcs}{
        TRUE if the structure should be plotted as arcs.  Arcs may be styled
        with styling columns, see example and \code{\link{plotHelix}} for
        details.
    }
    \item{add}{
        TRUE if graphical elements are to be added to an existing device, else
        a new plotting device is created with \code{\link{blankPlot}}.
    }
    \item{grid}{
        TRUE if the multiple sequence alignment is to be drawn as a grid of
        bases, else the multiple sequence alignment is drawn as equidistant
        horizontal lines.
    }
    \item{text}{
        Only applicable when grid is TRUE.  TRUE if the grid is to be filled
        with nucleotide character.
    }
    \item{legend}{
        TRUE if legend are to be shown.
    }
    \item{species}{
        If a number greater than 0 is given, then species names for
        the multiple sequence alignment will be printed along the left side.
        This name is typically the entire header lines of FASTA entries.  The
        number specifies the start position relative to the left edge of the
        multiple sequence alignment).
    }
    \item{base.colour}{
        TRUE if bases are to be coloured by nucleotide instead of basepair
        conservation.
    }
    \item{palette}{
        A list of colour names to override the default colour palette.  When
        base.colour is TRUE, the first 6 colours will be used for colouring
        bases A, U, G, C, - (gap), and ? (everything else), respectively.  When
        base.colour is FALSE, the first 7 colours will be used for colouring
        conserved basepairs, covarying basepairs, one-sided conserved basepairs,
        invalid basepairs, unpaired bases, gaps, and bases/pairs with ambiguous
        bases, resepctively.  If the palette is shorter than the expected
        length, the palette will simply cycle.  \dQuote{NA} is a valid colour,
        that will effectively plot nothing.
    }
    \item{flip}{
        If TRUE, the entire plot will be flipped upside down.  Note that this
        is \emph{not} a perfect mirror image about the horizon.
    }
    \item{grid.col, grid.lwd}{
        The colour and line width of the borders displayed when \code{grid} is
        TRUE.
    }    
    \item{text.cex, text.col, text.font, text.family}{
        cex, col, family and font for the text displayed via the \code{text}
        option.  Use \code{help("par")} for more information the paramters.
    }
    \item{species.cex, species.col, species.font, species.family}{
        cex, col, family and font for the species text displayed via the
        \code{species} option.  Use \code{help("par")} for more information the
        paramters.
    }
    \item{shape}{
        One of "circle", "triangle", or "square", specifying the shape of
        the arcs.
    }
    \item{conflict.lty, conflict.col, conflict.cutoff}{
        Determines the line type (style) and colour to be used for conflicting
        basepairs.  By default, conflicting helices are drawn as dotted lines
        (\code{lty = 2}) and whatever colour was originally assigned to it
        (\code{col = NA}). Conflicting helices may be coloured by setting
        \code{conflict.col} to some R-compatible colour name.  If both arguments
        are set to \code{NA}, then no attempt to exclude conflicting helices 
        will be made when colouring covariance plot columns, which in most cases
        will render the plot nonsensical.  When the input has helices with
        multiple basepairs, and only part of the helix is conflicting, the
        \code{conflict.cutoff} determines above what percentage of basepairs
        have to be conflicting before a helix is considered conflicting, with the
        default set at 1% (effectively any one conflicting basepairs makes a helix
        conflicting).
    }
    \item{miss}{
        The colour for unpredicted arcs in overlapping diagrams, see
        \code{plotOverlapHelix} for more information.
    }
    \item{overlap.cutoff}{
        Decimal between 0 and 1 indicating the percentage of basepairs within a helix
        that have to be overlapping for the entire helix to count as overlapping.
        Default is 1, or 100%.
    }
    \item{pad}{
        A four integer array passed to \code{\link{blankPlot}}, specifies the
        number of pixels to pad the bottom, left, top and right sides of the
        figure with, repsectively.
    }
    \item{x, y}{
        Coordinates for the left bottom corner of the plot.  Useful for manually
        positioning and overlapping figure elements.
    }
    \item{\dots}{
        In \code{plotCovariance}, these are additional arguments passed to
        \code{\link{blankPlot}}, useful arguments include \sQuote{lwd},
        \sQuote{col}, \sQuote{cex} for line width, line colour, and text size,
        respectively. \code{help('par')} for more.

        For \code{plotDoubleCovariance} and \code{plotOverlapCovariance}, these
        are additional arguments passed to \code{plotCovariance} (and thus
        indirectly also to \code{\link{blankPlot}}).
    }
}
\value{
    Not intended to return a value, will plot to GUI or file if specific.
}
\seealso{
    \code{\link{plotHelix}}

    \code{\link{plotDoubleHelix}}

    \code{\link{plotOverlapHelix}}

    \code{\link{colourByCovariation}}

    \code{\link{colourByConservation}}

    \code{\link{colourByCanonical}}
}
\author{
    Daniel Lai
}
\examples{
    data(helix)

    # Basic covariance plot
    plotCovariance(fasta, known, cex = 0.8, lwd = 1.5)

    # Grid mode
    plotCovariance(fasta, known, grid = TRUE, text = FALSE, cex = 0.8)

    # Global style and nucleotide colouring
    plotCovariance(fasta, known, grid = TRUE, text = FALSE, base.colour = TRUE)

    # Styling indivual helices with styling columns
    known$col <- c("red", "blue")
    plotCovariance(fasta, known, lwd = 2, cex = 0.8)

    # Use in combination with colourBy functions
    cov <- colourByCovariation(known, fasta, get = TRUE)
    plotCovariance(fasta, cov)
    legend("topleft", legend = attr(cov, "legend"),
        fill = attr(cov, "fill"), title = "Covariation")

}
\keyword{aplot}

\name{Log10 Space Operations}
\alias{logseq}
\alias{logfloor}
\alias{logceiling}

\title{
    Log base 10 sequence, floor and ceiling
}
\description{
    Sequence, floor and ceiling operations in log 10 space.
}
\usage{
    logseq(from, to, length.out)

    logfloor(x)

    logceiling(x)
}
\arguments{
    \item{from, to}{
        Positive non-zero values to start and end sequence, respectively.
    }
    \item{length.out}{
        The number of elements the resulting sequence should containg. If
        absent, function will attempt to generate numbers factors of 10 apart.
    }
    \item{x}{
        A value to round.
    }
}
\value{
    \code{logseq} returns an array numbers evenly distanced in log10-space.
    
    \code{logfloor} and \code{logceiling} return a value that is 10 raised
    to an integer number.
}

\author{
    Daniel Lai
}

\examples{
    logseq(1e-10, 1e3)
    logseq(1e-10, 1e3, length.out = 10)
    logceiling(2.13e-6)
    logfloor(2.13e-6)
}
\keyword{color}

\name{Coerce to Helix}
\alias{as.helix}
\alias{is.helix}
\alias{parseBracket}
\title{
    Coerce to a Helix Data Frame
}
\description{
    Functions to coerce a structure into a helix data frame, and to check
    whether a structure is a valid helix data frame.  A helix data frame is
    a data frame, so any structure coercible into a data.frame can become a
    helix data frame.
}
\usage{
    as.helix(x, length)
    is.helix(x)
}
\arguments{
    \item{x}{
        Structure to coerce.  Should be a structure coercible into a standard
        R data.frame structure for \code{\link{as.helix}}. Should be a string for
        \code{\link{parseBracket}}.  May be anything for \code{\link{is.helix}}.
    }
    \item{length}{
        The length of the RNA sequence containing the helices.
    }
}
\details{
    \code{\link{as.helix}} takes in a data.frame and coerces it into a 
    helix data frame acceptable by other R4RNA functions.  This mainly involves
    setting specific column names and casting to specific types.
}
\value{
    \code{\link{is.helix}} returns a boolean.

    \code{\link{as.helix}} returns helix data frame with valid input.
}
\author{
    Daniel Lai
}
\examples{
    # Not a valid helix data frame
    helix <- data.frame(c(1, 2, 3), seq(10, 20, length.out = 3), 5, runif(3))
    is.helix(helix)
    warnings()
    
    # Formatted into a helix data frame
    helix <- as.helix(helix)
    is.helix(helix)
}
\keyword{manip}

\name{Helix Type Filters}
\alias{isConflictingHelix}
\alias{isDuplicatingHelix}
\alias{isOverlappingHelix}
\title{
    Logical filters of helix by type
}
\description{
    Given a helix data frame, checks if helices are conflicting, duplicating, or
    overlapping, and returns an array of numeric values, where 0 is FALSE and 1 is
    TRUE.  Values in between 0 and 1 occur when a single helix has multiple
    basepairs with different values, the number observed in this case is the mean
    of the basepair values within the helix. See details for exact definition of
    the three types of events.
}
\usage{
    isConflictingHelix(helix)
    isDuplicatingHelix(helix)
    isOverlappingHelix(helix, query)
}
\arguments{
    \item{helix}{
        A helix data frame
    }
    \item{query}{
        For \code{isOverlappingHelix}, a helix data structure against which
        \code{helix} will be checked for overlap against.
    }
}
\details{
    Helices of length greater than 1 are internally expanded into basepairs of
    length 1, after which the following conditions are evaluated:

    A \bold{conflicting} basepair is one where at least one of its two positions
    is used by either end of another basepair.

    A \bold{duplicating} basepair is one where both of its positions are used
    by both ends of another basepair.

    An \bold{overlapping} basepair is one in \code{helix} where both of its
    positions are used by both ends of another basepair in the \code{query}
    structure.

    In the case of \emph{conflicting} and \emph{duplicating} basepairs, for a
    set of basepairs that satisfies this condition, the basepair situation
    highest on the data frame will be exempt from the condition. i.e.  Say 5
    basepairs are all duplicates of each other, the top 1 will return FALSE,
    while the bottom 4 will return TRUE.  This assumes some significant meaning
    to the ordering of rows prior to using this function.  This is to be used
    with \code{which} to filter out basepairs that satisfy these conditions,
    leaving a set of basepairs free of these events.

    If the original input had helices greater than length 1, then after applying
    all of the above, TRUE is treated as 1, FALSE as 0, and the average of values
    from each basepair is taken as the value for the helix in question.
}
\value{
    Returns an array of numerics corresponding to each row of \code{helix}, giving
    the average conditional status of the helix, where 0 signifying all basepairs
    are FALSE, and 1 where all basepairs are TRUE.
}
\author{
    Daniel Lai
}

\examples{
    data(helix)

    conflicting <- isConflictingHelix(helix)
    duplicating <- isDuplicatingHelix(helix)

    # Nonsensical covariation plot
    plotCovariance(fasta, helix)

    # Plot nonconflicting helices
    plotCovariance(fasta, helix[(!conflicting & !duplicating), ])

    # Similar result
    plotCovariance(fasta, helix, conflict.col = "lightgrey")
}
\keyword{logic}

\name{Plot Helix Structures}
\alias{plotHelix}
\alias{plotDoubleHelix}
\alias{plotOverlapHelix}
\alias{plotArcs}
\alias{plotArc}
\title{
    Plots helices in arc diagram
}
\description{
    Plots a helix data frame as an arc diagram, with styling possible with
    properly named additional columns on the data frame. 
}
\usage{
    plotHelix(helix, x = 0, y = 0, flip = FALSE, line = FALSE, arrow = FALSE,
        add = FALSE, shape = "circle", ...)
    plotDoubleHelix(top, bot, line = TRUE, arrow = FALSE, add = FALSE, ...)
    plotOverlapHelix(predict, known, miss = "black", line = TRUE,
        arrow = FALSE, add = FALSE, overlap.cutoff = 1, ...)
    plotArcs(i, j, length, x = 0, y = 0, flip = FALSE, shape = "circle", ...)
    plotArc(i, j, x = 0, y = 0, flip = FALSE, shape = "circle", ...)

}
\arguments{
    \item{helix, top, bot, predict, known}{
        Helix data.frames, with the four mandatory columns.  Any other column
        will be considered a styling column, and will be used for styling the
        helix.  See \code{example} for styling usage.  See \code{Details} for
        exact usage of each helix.
    }
    \item{x, y}{
        The coordinate of the left bottom corner of the plot, useful for
        manually positioning figure elements.
    }
    \item{flip}{
        If TRUE, flips the arcs upside down about the y-axis.
    }
    \item{line}{
        If TRUE, a horizontal line representing the sequence is plotted.
    }
    \item{arrow}{
        If TRUE, an arrow is played on the right end of the line.
    }
    \item{add}{
        If TRUE, graphical elements are added to the active plot device, else
        a new plot device is created for the plot.
    }
    \item{shape}{
        One of "circle", "triangle", or "square", specifying the shape of
        the arcs.
    }
    \item{miss}{
        The colour for unpredicted arcs in overlapping diagrams, see
        \code{details} for more information.
    }
    \item{overlap.cutoff}{
        Decimal between 0 and 1 indicating the percentage of basepairs within a helix
        that have to be overlapping for the entire helix to count as overlapping.
        Default is 1, or 100%.
    }
    \item{i, j}{
        The starting and ending position of the arc along the x-axis
    }
    \item{length}{
        The total number of arcs to draw by incrementing \emph{i} and
        decrementing \emph{j}.  Used to draw helices.
    }
    \item{\dots}{
        Any additional parameters passed to \code{par}
    }
}
\details{
  \code{plotHelix} creates a arc diagram with all arcs on top,
  \code{plotDoubleHelix} creates a diagram with arcs on the top and bottom.
  \code{plotOverlapHelix} is slight trickier, and given two structures
  \code{predict} and \code{known}, plots the predicted helices that are known
  on top, predicted helices that are not known on the bottom, and finally plots
  unpredicted helices on top in the colour defined by \code{miss}.
  
  \code{plotArc} and \code{plotArcs} are the core functions that make everything
  work, and may be used for extreme fine-tuning and customization.
}
\value{
    Not intended to return a value, will plot to GUI or file if specific.
}
\seealso{
    \code{\link{colourByCount}}
}
\author{
    Daniel Lai
}
\examples{
    data(helix)

    # Plot helix plain
    plotHelix(known)

    # Apply global appearance options
    plotHelix(known, line = TRUE, arrow = TRUE, col = "blue", lwd = 1.5)

    # Add extra column with styling options
    known$lty <- 1:4
    known$lwd <- 1:2
    known$col <- c(rgb(1, 0, 0), "orange", "yellow", "#00FF00", 4, "purple")
    plotHelix(known)

    # Manually colour helices according to value
    helix$col <- "red"
    helix$col[which(helix$value < 1e-3)] <- "orange"
    helix$col[which(helix$value < 1e-4)] <- "green"
    helix$col[which(helix$value < 1e-5)] <- "blue"
    plotHelix(helix)

    # Automatically creating a similar plot with legend
    coloured <- colourByValue(helix, log = TRUE, get = TRUE)
    plotHelix(coloured, line = TRUE, arrow = TRUE)
    legend("topleft", legend = attr(coloured, "legend"),
        fill = attr(coloured, "fill"), title = "P-value", text.col = "black")    

    # Plot both helices with styles
    plotDoubleHelix(helix, known)

    # Overlap helix
    plotOverlapHelix(helix, known)
}
\keyword{aplot}

\name{Basepair Frequency}
\alias{basepairFrequency}
\title{
    Calculates the frequency of each basepair
}
\description{
    Calculates the frequency of each basepair in a given helix structure.
    Internally, breaks helices into basepairs, and returns a structure of
    unique basepairs, where the values is its frequency, regardless of original
    value.
}
\usage{
    basepairFrequency(helix) 
}
\arguments{
    \item{helix}{
        A helix data.frame
    }
}
\value{
    A helix data.frame of unique basepairs of length 1, with the frequency
    of appearance as its value, sorted by decreasing value.
}
\seealso{
    \code{\link{colourByBasepairFrequency}}
}
\author{
    Daniel Lai
}
\examples{
    data(helix)
    basepairFrequency(helix)
}
\keyword{aplot}

\name{Read Structure File}
\alias{readHelix}
\alias{readConnect}
\alias{readVienna}
\alias{readBpseq}

\title{
    Read secondary structure file
}
\description{
    Reads in secondary structure text files into a helix data frame.
}
\usage{
    readHelix(file)
    readConnect(file)
    readVienna(file, palette = NA)
    readBpseq(file)
}
\arguments{
    \item{file}{
        A text file in connect format, see details for format specifications.
    }
    \item{palette}{
        Used to colour basepairs by bracket type.  See
        \code{\link{viennaToHelix}} for more details.
    }

}
\details{
    \bold{Helix}: Files start with a header line beginning with # followed by
    the sequence length, followed by a four-column tab-delimited table (with
    column names), where each row corresponds to a helix in the structure.  The
    four columns are \emph{i} and \emph{j} for the left-most and right-most
    basepair positions respectively, the \emph{length} of the helix (converging
    inwards from i and j, and finally an arbitrary \emph{value} assigned to the
    helix.
    
    \bold{Vienna}: Dot-bracket notation from Vienna package programs, where each
    structure consists of matched brackets for basepairs and periods for unbased
    pairs.  Valid brackets are (, {, [, <, A, B, C, D matched with ), }, ], >,
    a, b, c, d, respectively.  An energy value can be appended to
    the end of any dot-bracket structure.  The function will accept slight
    variations of the format, including those with FASTA-like headers (in which
    case line breaks are allows), and those without FASTA-like headers (in which
    case line breaks are NOT allowed), with both types allowing for a preceding
    (NOT following) nucleotide sequence for the structure.  Multiple entries
    \emph{of the same length} may be in a single file, which will be returned
    as a single helix structure, with respectively energy values (if specified).
    
    \bold{Connect}: Output from mfold and other programs, this format is
    expected to be a text file beginning with a header line that starts with the
    sequence length, with an optional Energy/dG value, followed by a six-column
    tab-delimited table where columns 1 and 5 denote the position that are
    basepaired (unpaired when column 5 is 0).  Other columns are ignored, but
    for completeness, column 2 is the nucleotide, column 3 and 4 are the
    positions of the bases left and right of the base specified in column 1
    respectively (with 0 denoting non-existance), and column 6 a copy of column
    1. Multiple entries \emph{of the same length} may be in a single file, which
    will be returned as a single helix structure. All helices will be assigned
    the energy value extracted from their respective structure header lines.
    
    \bold{Bpseq}: Format used by the Gutell Lab's Comparative RNA Website.  The
    file may optionally begin several header lines (e.g. Filename,
    Organism, Accession, etc.), followed by a 3-column tab-delimited table for
    the structure, where column 1 is the base position, base 2 is the nucleotide
    base, and column 3 is the paired position (0 if unpaired).  Certain pieces
    of header information will be parsed and returned as attributes of the
    output data frame.  Multiple structures can be within a single file,
    returned as a single helix data frame, with attributes set to those of the
    first entry.

}
\value{
    Returns a helix format data frame.
}
\author{
    Daniel Lai, Jeff Proctor
}

\examples{
    file <- system.file("extdata", "helix.txt", package = "R4RNA")
    helix <- readHelix(file)
    head(helix)

    file <- system.file("extdata", "connect.txt", package = "R4RNA")
    connect <- readConnect(file)
    head(connect)
    message("Note connect data assigns structure energy level to all basepairs")

    file <- system.file("extdata", "vienna.txt", package = "R4RNA")
    vienna <- readVienna(file)
    head(vienna)
    message("Note vienna data assigns structure energy level to all basepairs")

    file <- system.file("extdata", "bpseq.txt", package = "R4RNA")
    bpseq <- readBpseq(file)
    head(bpseq)
    message("Note bpseq data has no value assigned to basepairs")
}
\keyword{IO}
\keyword{file}

\name{Create Blank Plot}
\alias{blankPlot}
\alias{maxHeight}
\title{
    Create a blank plotting canvas
}
\description{
    Creates a blank plotting canvas with the given dimensions, along with
    functions to find best values for the canvas dimensions.
}
\usage{
    blankPlot(width, top, bottom, pad = c(0, 0, 0, 0), scale = TRUE,
        scale.lwd = 1, scale.col = "#DDDDDD", scale.cex = 1, debug = FALSE,
        png = NA, pdf = NA, factor = ifelse(!is.na(png), 8, 1/9),
        no.par = FALSE, asp = 1,...)
    maxHeight(helix)
}
\arguments{
    \item{width}{
        A number indicating the horizontal width of the blank plot.
    }
    \item{top, bottom}{
        The maximum and minimum values vertically to be displayed in the plot.
    }
    \item{pad}{
        An array of 4 integers, specifying the pixels of whitespace to pad
        beyond the dimensions given by top, bottom, and width.  Four number
        corresponding to padding on the bottom, left, top and right,
        respectively.  Default is c(0, 0, 0, 0).
    }
    \item{scale}{
        If TRUE, inserts a scale on the plot.
    }
    \item{scale.lwd, scale.col, scale.cex}{
        Allows manual modification of the scale's line width and colour,
        respectively.
    }
    \item{png, pdf}{
        If one or the other is set to a filename, a file in png or pdf format
        will be produced respectively.  If both are set to non-NA values,
        \code{png} will have priority.
    }
    \item{factor}{
        The scaling factor used to produce plots of png or pdf format.  Should
        be set so after multiplication of the \code{top, bot}, etc arguments,
        good document dimension in pixels with \code{png} and inches for
        \code{pdf} will be produced.
    }
    \item{debug}{
        If TRUE, frames the boundaries of the intended plotting space in red,
        used to determine if inputs produce expected output area.  Also outputs
        to STDIN dimensions of the plot.
    }
    \item{no.par}{
        Suppresses the internal call to \code{par} in the function if set to
        TRUE, useful for using \code{par} arguments such as \code{mfrow}, etc.
    }
    \item{asp}{
        Controls and aspect ratio of the plot, defaultly set to 1, set to NA
        to disable completely.
    }
    \item{\dots}{
        Additional arguments passed to \code{\link{par}} when \code{no.par}
        is FALSE, common ones include \sQuote{lwd}, \sQuote{col}, \sQuote{cex}
        for line width, line colour, and text size, respectively.
        \code{help('par')} for more.  When \code{no.par} is set to TRUE, this
        option does nothing, and manually calling \code{par} is required prior
        to the calling of this function.
    }
    \item{helix}{
        A helix data.frame
    }
}
\details{
    \code{blankPlot} creates a blank plot with the given dimensions, with
    minimal margins around the plot and no axis or labels.  If more control
    is required, using \code{\link{plot}} directly would be more efficient.

    \code{maxHeight} returns the height that the highest helix would require,
    and can be used to determine \code{top} and \code{bottom} for
    \code{blankPlot}.
}
\value{
    \code{maxHeight} returns a numeric integer.
}
\seealso{
    \code{\link{plotHelix}}
}
\author{
    Daniel Lai
}

\examples{
    # Create helix and obtain height
    helix <- as.helix(data.frame(1, 37, 12, 0.5))
    height <- maxHeight(helix)
    print(height)

    # Use height to create properly sized plot
    width <- attr(helix, "length")
    blankPlot(width, height, 0)

    # Add helix to plot
    plotHelix(helix, add = TRUE)
}
\keyword{aplot}

\name{Basepair/Helix Conversion}
\alias{expandHelix}
\alias{collapseHelix}
\title{
    Expand or collapse helices to and from basepairs
}
\description{
    Given a helix data frame, expands a helix of arbitrary length into helices
    of length 1 (i.e. basepairs).  Also does the reverse operation of clustering
    consecutive basepairs (or helices), and merging/collapsing them into a
    single helix.
}
\usage{
    expandHelix(helix)
    collapseHelix(helix, number = FALSE)
}
\arguments{
    \item{helix}{
        A helix data frame.
    }
    \item{number}{
        Indicates presence of a column in the helix data frame titled exactly
        'number', which will be used to unique identify basepairs belonging
        to the same helix.  Only basepairs from the same helix as identified
        by the number will be collapsed together.
    }
}
\details{
    During the expansion, basepairs expanded from a single helix will all be
    assigned the value of the originating helix (the same goes for all other
    columns besides i, j, and length).  During collapsing, only
    helices/basepairs of equal value will be grouped together.  The ordering
    of collapsed helices returned will be sorted by value (increasing order).
    For any other columns besides i, j, length and value, values will be
    obtained from the corresponding columns of the outer most basepair.
}
\value{
    Returns a helix data frame.
}
\author{
    Daniel Lai
}

\examples{
    # Create helix data frame
    helix <- data.frame(2, 8, 3, 0.5)
    helix[2, ] <- c(5, 15, 4, -0.5)
    helix <- as.helix(helix)
    helix$colour <- c("red", "blue")

    # Before expansion
    print(helix)
    # After expansion
    print(expanded <- expandHelix(helix))
    # Collapse back (sorted by value)
    print(collapseHelix(expanded))
}
\keyword{manip}

\name{Alignment Statistics}
\alias{baseConservation}
\alias{basepairCanonical}
\alias{basepairConservation}
\alias{basepairCovariation}
\alias{helixCanonical}
\alias{helixConservation}
\alias{helixCovariation}
\alias{alignmentConservation}
\alias{alignmentCovariation}
\alias{alignmentCanonical}
\alias{alignmentPercentGaps}

\title{
    Compute statistics for a multiple sequence alignments
}
\description{
    Functions to compute covariation, percent identity conservation, and percent
    canonical basepairs given a multiple sequence alignment and optionally a
    secondary structure.  Statistics can be computed for a single base,
    basepair, helix or entire alignment.
}
\usage{
    baseConservation(msa, pos)

    basepairConservation(msa, pos.5p, pos.3p)
    basepairCovariation(msa, pos.5p, pos.3p) 
    basepairCanonical(msa, pos.5p, pos.3p)

    helixConservation(helix, msa)
    helixCovariation(helix, msa)
    helixCanonical(helix, msa) 

    alignmentConservation(msa)
    alignmentCovariation(msa, helix)
    alignmentCanonical(msa, helix)
    
    alignmentPercentGaps(msa)
}
\arguments{
    \item{helix}{
        A helix data.frame
    }
    \item{msa}{
        A multiple sequence alignment.  Can be either a \code{Biostrings}
        \code{XStringSet} object or a named array of strings like ones obtained
        from converting XStringSet with \code{as.character}.
    }
    \item{pos, pos.5p, pos.3p}{
        Positions of bases or basepairs for which statistics shall be calculated
        for.
    }
}

\details{
    Conservation values have a range of [0, 1], where 0 is the absence of
    primary sequence conservation (all bases different), and 1 is full
    primary sequence conservation (all bases identical).
    
    Canonical values have a range of [0, 1], where 0 is a complete lack of
    basepair potential, and 1 indicates that all basepairs are valid

    Covariation values have a range of [-2, 2], where -2 is a complete lack of
    basepair potential and sequence conservation, 0 is complete sequence
    conservation regardless of basepairing potential, and 2 is a complete lack
    of sequence conservation but maintaining full basepair potential.

    \code{helix} values are average of base/basepair values, and the
    \code{alignment} values are averages of helices or all columns depending
    on whether the \code{helix} argument is required.    

    \code{alignmentPercentGaps} simply returns the percentage of nucleotides
    that are gaps in a sequence for each sequence of the alignment.
}

\value{
    \code{baseConservation}, \code{basepairConservation},
    \code{basepairCovariation}, \code{basepairCanonical},
    \code{alignmentConservation}, \code{alignmentCovariation}, and
    \code{alignmentCanonical}
    return a single decimal value.

    \code{helixConservation}, \code{helixCovariation}, \code{helixCanonical}
    return a list of values whose length equals the number of rows in \code{helix}.

    \code{alignmentPercentGaps} returns a list of values whose length equals
    the number of sequences in the multiple sequence alignment.
}

\author{
    Jeff Proctor, Daniel Lai
}

\examples{
    data(helix)
    
    baseConservation(fasta, 9)

    basepairConservation(fasta, 9, 18)
    basepairCovariation(fasta, 9, 18) 
    basepairCanonical(fasta, 9, 18)

    helixConservation(helix, fasta)
    helixCovariation(helix, fasta)
    helixCanonical(helix, fasta)

    alignmentConservation(fasta)
    alignmentCovariation(fasta, helix)
    alignmentCanonical(fasta, helix)

    alignmentPercentGaps(fasta)
}
\keyword{math}

\name{Example Data}
\docType{data}
\alias{helix}
\alias{fasta}
\alias{known}
\title{Helices predicted by TRANSAT with p-values}
\description{
    This data set contains two sets of helices and a multiple sequence alignment. 
    The two sets of helices are \code{helices} and \code{known} which are
    helices predicted to occur for RNA sequence RF00458 by the program TRANSAT,
    and experimentally proposed structure of the same sequence, respectively.
    \code{fasta} is the seed homologues for the multiple sequence alignment
    obtained from the RFAM database.
}
\value{
	\code{fasta} is an array of strings, \code{helix} and \code{known} are
	data.frames in ``helix'' format.
}
\usage{
    data(helix)
}
\format{
    \code{helix} and \code{known} are 4 column data frames, where columns
    \bold{i} and \bold{j} denote the left-most and right-most basepairs, the
    \bold{length} is the number of \emph{consecutive} basepairs the helix
    contains, and the \bold{value} is assigned to each helix on a row.
    
    \code{fasta} is an array of named characters of length 7.
}
\references{
    Wiebe NJ, Meyer IM. (2010) \emph{TRANSAT-- method for detecting the
    conserved helices of functional RNA structures, including transient,
    pseudo-knotted and alternative structures}.  PLoS Comput Biol.
    6(6):e1000823.

    Gardner PP, Daub J, Tate J, Moore BL, Osuch IH, Griffiths-Jones S, Finn RD,
    Nawrocki EP, Kolbe DL, Eddy SR, Bateman A. (2011) \emph{Rfam: Wikipedia,
    clans and the ``decimal'' release}.  Nucleic Acids Res. 39(Database
    issue):D141-5.
}
\keyword{datasets}

\name{Structure Mismatch Score}
\alias{structureMismatchScore}
\title{
    Scores how a basepair structure fits a sequence
}
\description{
    Calculates a score that indicates how badly a set of basepairs (i.e. a
    secondary structure) fits with a sequence.  A perfect fit is a structure
    where all basepairs form valid basepairs (A:U, G:C, G:U, and equivalents)
    and has a score of 0.  Each basepair that forms a non-canonical pairing
    or pairs to gaps increases the score by 1, and each base-pair with a
    single-sided gap increases the score by 2.
}
\usage{
    structureMismatchScore(msa, helix, one.gap.penalty = 2, two.gap.penalty = 2,
                 invalid.penalty = 1)
}
\arguments{
    \item{msa}{
        A multiple sequence alignment.  Can be either a \code{Biostrings}
        \code{XStringSet} object or a named array of strings like ones obtained
        from converting XStringSet with \code{as.character}.
    }
    \item{helix}{
        A helix data.frame
    }
    \item{one.gap.penalty}{
        Penalty score for basepairs with one of the bases being a gap
    }
    \item{two.gap.penalty}{
        Penalty score for basepairs with both bases being a gaps
    }
    \item{invalid.penalty}{
        Penalty score for non-canonical basepairs
    }
}
\value{
    Returns an array of mismatch scores.
}
\author{
    Jeff Proctor, Daniel Lai
}
\examples{
    data(helix)
    mismatch <- structureMismatchScore(fasta, known)
    
    # Sort by increasing mismatch
    sorted_fasta <- fasta[order(mismatch)]
}
\keyword{math}

\name{Colour Helices}
\alias{colourByCount}
\alias{colourByValue}
\alias{colourByConservation}
\alias{colourByCovariation}
\alias{colourByCanonical}
\alias{colourByBasepairFrequency}
\alias{colourByUnknottedGroups}
\alias{defaultPalette}

\title{
    Assign colours to helices
}
\description{
    Functions to generate colours for helices by various rules, including
    integer counts, value ranges, percent identity covariation, conservation,
    percentage canonical basepair, basepair frequency, and non-pseudoknotted
    groups.
}
\usage{
    colourByCount(helix, cols, counts, get = FALSE)
    colourByValue(helix, cols, breaks, get = FALSE,
        log = FALSE, include.lowest = TRUE, ...)
    colourByBasepairFrequency(helix, cols, get = TRUE)
    colourByUnknottedGroups(helix, cols, get = TRUE)
    colourByCovariation(helix, msa, cols, get = FALSE)
    colourByConservation(helix, msa, cols, get = FALSE)
    colourByCanonical(helix, msa, cols, get = FALSE)
    defaultPalette()
}
\arguments{
    \item{helix}{
        A helix data frame to be coloured.
    }
    \item{cols}{
        An array of characters (or numbers) representing a set of colours to
        colour \code{helix} with.  When missing, a default set of colours from
        defaultPalette() will be used.  Valid input include hex codes, colour
        names from the \code{colours} function, and integer numbers.  The
        colours will be interpreted as being from best to worst.
    }
    \item{counts}{
        An array of integers the same length as \code{cols}, dictating the
        number of times each corresponding colour should be used.  When missing,
        the function will divide the number of helices evenly over each of the
        colours available.
    }
    \item{breaks}{
        An integer number of intervals to break the \sQuote{value} column of
        \code{helix} into, or a list of numbers defining the interval breaks.
        If missing, the range of \sQuote{helix$value} will automatically be
        split evenly into intervals for each colour available.
    }
    \item{get}{
        If TRUE, returns the input \code{helix} with a \code{col} column, else
        simply returns an array of colours the same length as the number of row
        in \code{helix}.  The exceptions are \code{colourByBasepairFrequency}
        and \code{colourByUnknottedGroups} which will return a different helix
        if TRUE, and a list of colours that will not match the input helix if
        FALSE.
    }
    \item{log}{
        If TRUE, will breaks values into even log10 space intervals, useful
        when values are p-values.
    }
    \item{include.lowest}{
        Whether the lowest interval should include the lowest value, passed to
        \code{\link{cut}}
    }
    \item{...}{
        Additional arguments passed to \code{\link{cut}}, potentially useful
        ones include \code{right} (whether intervals should be inclusive on the
        right or left) and \code{dig.lab} (number of digits in interval labels).
    }
    \item{msa}{
        A multiple sequence alignment.  Can be either a \code{Biostrings}
        \code{XStringSet} object or a named array of strings like ones obtained
        from converting XStringSet with \code{as.character}.
    }
}
\details{
    \code{colourByCount} assigns colours indepenent of the helix input's value
    column, and instead operates over the number of helices (i.e. rows).
    
    \code{colourByValue} uses \code{\link{cut}} to assign each of the helices
    to an interval based on its value.
    
    \code{colourByCovariation}, \code{colourByConservation} , and
    \code{colourByCanonical}, colour helices according to compensatory mutations
    (or covariation), percentage identity conservation, and percentage canonical
    basepair repsectively, relative to the multiple sequence alignment provided.

    \code{colourByBasepairFrequency} colours each basepair according to the
    number of times it appear in the input, regardless of its value.

    \code{colourByUnknottedGroups} greedily partitions the basepairs into non-
    pseudoknotted groups, and assigns a colour to each.
}

\value{
    All \dQuote{colourBy} functions return a list of colours when \code{get =
    FALSE}, and a helix with a \code{col} column if \code{get = TRUE}.  In both
    bases, the returned object has attributes \dQuote{legend} and \dQuote{fill},
    showing the mapping between interval (in legend) and colour (in fill),
    which can as eponymous arguments \code{\link{legend}}.
    
    \code{defaultPalette} returns the default list of colours.
}
\seealso{
    \code{\link{plotHelix}}

    \code{\link{logseq}}

    \code{\link{basepairFrequency}}

    \code{\link{unknottedGroups}}
}

\author{
    Daniel Lai
}

\examples{
    data(helix)

    known$col <- colourByCount(known)
    plotHelix(known)

    plotHelix(colourByValue(helix, log = TRUE, get = TRUE))

    cov <- colourByCovariation(known, fasta, get = TRUE)
    plotCovariance(fasta, cov)
    legend("topleft", legend = attr(cov, "legend"),
        fill = attr(cov, "fill"), title = "Covariation")

}
\keyword{color}

\name{Write Helix}
\alias{writeHelix}
\title{
    Write out a helix data frame into a text file
}
\description{
    Write out a helix data frame into a text file into the four-column
    tab-delimited format with proper header and column names.
}
\usage{
    writeHelix(helix, file = stdout())
}
\arguments{
    \item{helix}{
        A helix data frame.
    }
    \item{file}{
        A character string pointing to a file path, or a file connection.
        Defaults to the console.
    }
}
\value{
    No value returned, will write to STDOUT or specific file location.
}
\author{
    Daniel Lai
}
\examples{
    # Create helix data frame
    helix <- data.frame(2, 8, 3, 0.5)
    helix[2, ] <- c(5, 15, 4, -0.5)
    helix <- as.helix(helix)

    writeHelix(helix)
}
\keyword{IO}
\keyword{file}
